--  C:\08ABR_10H\LLAMADAS.vhd
--  VHDL code created by Xilinx's StateCAD 6.2i
--  Fri Apr 08 17:24:38 2005

--  This VHDL code (for use with Xilinx XST) was generated using: 
--  binary encoded state assignment with boolean code format.
--  Minimization is enabled,  implied else is enabled, 
--  and outputs are speed optimized.

LIBRARY ieee;
USE ieee.std_logic_1164.all;

LIBRARY ieee;
USE ieee.std_logic_unsigned.all;

ENTITY SHELL_LLAMADAS IS
	PORT (CLK,cifra_mem0,cifra_mem1,cifra_mem2,cifra_mem3,empieza_a_llamar,RESET
		: IN std_logic;
		columna0,columna1,columna2,columna3,fin_llamada,senyal : OUT std_logic);
END;

ARCHITECTURE BEHAVIOR OF SHELL_LLAMADAS IS
--	State variables for machine sreg
	SIGNAL SV0, next_SV0,SV1, next_SV1,SV2, next_SV2,SV3, next_SV3 : std_logic;
	SIGNAL next_BP_columna0,next_BP_columna1,next_BP_columna2,next_BP_columna3,
		next_BP_fin_llamada,next_BP_senyal,next_pulsos0,next_pulsos1,next_pulsos2,
		next_pulsos3 : std_logic;
	SIGNAL BP_columna : std_logic_vector (3 DOWNTO 0);
	SIGNAL columna : std_logic_vector (3 DOWNTO 0);
	SIGNAL pulsos : std_logic_vector (3 DOWNTO 0);

	SIGNAL BP_columna0,BP_columna1,BP_columna2,BP_columna3,BP_fin_llamada,
		BP_senyal,pulsos0,pulsos1,pulsos2,pulsos3: std_logic;
BEGIN
	PROCESS (CLK, RESET, next_SV0, next_SV1, next_SV2, next_SV3, 
		next_BP_fin_llamada, next_BP_senyal, next_BP_columna3, next_BP_columna2, 
		next_BP_columna1, next_BP_columna0, next_pulsos3, next_pulsos2, next_pulsos1,
		 next_pulsos0)
	BEGIN
		IF ( RESET='1' ) THEN
			SV0 <= '1';
			SV1 <= '0';
			SV2 <= '0';
			SV3 <= '0';
			BP_fin_llamada <= '0';
			BP_senyal <= '0';
			pulsos3 <= '0';
			pulsos2 <= '0';
			pulsos1 <= '0';
			pulsos0 <= '0';
			BP_columna3 <= '0';
			BP_columna2 <= '1';
			BP_columna1 <= '1';
			BP_columna0 <= '1';
		ELSIF CLK='1' AND CLK'event THEN
			SV0 <= next_SV0;
			SV1 <= next_SV1;
			SV2 <= next_SV2;
			SV3 <= next_SV3;
			BP_fin_llamada <= next_BP_fin_llamada;
			BP_senyal <= next_BP_senyal;
			BP_columna3 <= next_BP_columna3;
			BP_columna2 <= next_BP_columna2;
			BP_columna1 <= next_BP_columna1;
			BP_columna0 <= next_BP_columna0;
			pulsos3 <= next_pulsos3;
			pulsos2 <= next_pulsos2;
			pulsos1 <= next_pulsos1;
			pulsos0 <= next_pulsos0;
		END IF;
	END PROCESS;

	PROCESS (BP_columna0,BP_columna1,BP_columna2,BP_columna3,BP_fin_llamada,
		BP_senyal,cifra_mem0,cifra_mem1,cifra_mem2,cifra_mem3,empieza_a_llamar,
		pulsos0,pulsos1,pulsos2,pulsos3,SV0,SV1,SV2,SV3,BP_columna,pulsos)
	BEGIN


		IF (( SV0='0' AND SV1='0' AND SV2='0' AND SV3='1' ) OR ( 
			empieza_a_llamar='1' AND SV0='1' AND SV1='0' AND SV2='0' AND SV3='0' )) THEN 
			next_SV0<='1';
		ELSE next_SV0<='0';
		END IF;

		IF (( SV0='0' AND SV1='1' AND SV3='0' ) OR ( pulsos0='0' AND pulsos1='0' 
			AND pulsos2='0' AND pulsos3='0' AND SV0='0' AND SV2='1' AND SV3='0' ) OR ( 
			SV0='0' AND SV1='1' AND SV2='0' )) THEN next_SV1<='1';
		ELSE next_SV1<='0';
		END IF;

		IF (( SV0='0' AND SV1='0' AND SV2='1' ) OR ( SV0='0' AND SV2='0' AND 
			SV3='0' )) THEN next_SV2<='1';
		ELSE next_SV2<='0';
		END IF;

		IF (( BP_columna0='1' AND BP_columna1='1' AND BP_columna2='1' AND 
			BP_columna3='1' AND SV0='0' AND SV1='1' AND SV2='1' ) OR ( pulsos3='1' AND 
			SV0='0' AND SV3='0' ) OR ( pulsos2='1' AND SV0='0' AND SV3='0' ) OR ( 
			pulsos1='1' AND SV0='0' AND SV3='0' ) OR ( pulsos0='1' AND SV0='0' AND 
			SV3='0' ) OR ( SV0='0' AND SV1='1' AND SV3='0' ) OR ( SV0='0' AND SV2='0' AND
			 SV3='0' )) THEN next_SV3<='1';
		ELSE next_SV3<='0';
		END IF;

		BP_columna<= ((  std_logic_vector'( NOT SV0, NOT SV0, NOT SV0, NOT SV0)) 
			AND (  std_logic_vector'( NOT SV1, NOT SV1, NOT SV1, NOT SV1)) AND (  
			std_logic_vector'( NOT SV2, NOT SV2, NOT SV2, NOT SV2)) AND (  
			std_logic_vector'( NOT SV3, NOT SV3, NOT SV3, NOT SV3)) AND  ( 
			std_logic_vector'("1111") ) AND  (( std_logic_vector'(NOT BP_columna3, NOT 
			BP_columna2, NOT BP_columna1, NOT BP_columna0)) ) ) OR  ((  std_logic_vector'
			( NOT SV0, NOT SV0, NOT SV0, NOT SV0)) AND (  std_logic_vector'( NOT SV1, NOT
			 SV1, NOT SV1, NOT SV1)) AND (  std_logic_vector'( SV2, SV2, SV2, SV2)) AND (
			  std_logic_vector'( NOT SV3, NOT SV3, NOT SV3, NOT SV3)) AND  ((  
			std_logic_vector'( NOT pulsos0, NOT pulsos0, NOT pulsos0, NOT pulsos0)AND  
			std_logic_vector'( NOT pulsos1, NOT pulsos1, NOT pulsos1, NOT pulsos1)AND  
			std_logic_vector'( NOT pulsos2, NOT pulsos2, NOT pulsos2, NOT pulsos2)AND  
			std_logic_vector'( NOT pulsos3, NOT pulsos3, NOT pulsos3, NOT pulsos3)) ) AND
			  (( std_logic_vector'(NOT BP_columna3, NOT BP_columna2, NOT BP_columna1, NOT
			 BP_columna0)) ) ) OR  ((  std_logic_vector'( NOT SV0, NOT SV0, NOT SV0, NOT 
			SV0)) AND (  std_logic_vector'( NOT SV1, NOT SV1, NOT SV1, NOT SV1)) AND (  
			std_logic_vector'( SV2, SV2, SV2, SV2)) AND (  std_logic_vector'( NOT SV3, 
			NOT SV3, NOT SV3, NOT SV3)) AND  ((  std_logic_vector'( pulsos0, pulsos0, 
			pulsos0, pulsos0)) OR (  std_logic_vector'( pulsos1, pulsos1, pulsos1, 
			pulsos1)) OR (  std_logic_vector'( pulsos2, pulsos2, pulsos2, pulsos2)) OR ( 
			 std_logic_vector'( pulsos3, pulsos3, pulsos3, pulsos3)) ) AND  (( 
			std_logic_vector'(NOT BP_columna3, NOT BP_columna2, NOT BP_columna1, NOT 
			BP_columna0)) ) ) OR  ((  std_logic_vector'( NOT SV0, NOT SV0, NOT SV0, NOT 
			SV0)) AND (  std_logic_vector'( NOT SV1, NOT SV1, NOT SV1, NOT SV1)) AND (  
			std_logic_vector'( SV2, SV2, SV2, SV2)) AND (  std_logic_vector'( SV3, SV3, 
			SV3, SV3)) AND  ( std_logic_vector'("1111") ) AND  (( std_logic_vector'(NOT 
			BP_columna3, NOT BP_columna2, NOT BP_columna1, NOT BP_columna0)) ) ) OR  ((  
			std_logic_vector'( NOT SV0, NOT SV0, NOT SV0, NOT SV0)) AND (  
			std_logic_vector'( SV1, SV1, SV1, SV1)) AND (  std_logic_vector'( NOT SV2, 
			NOT SV2, NOT SV2, NOT SV2)) AND (  std_logic_vector'( SV3, SV3, SV3, SV3)) 
			AND  ( std_logic_vector'("1111") ) AND  (( std_logic_vector'(NOT BP_columna3,
			 NOT BP_columna2, NOT BP_columna1, NOT BP_columna0)) ) ) OR  ((  
			std_logic_vector'( NOT SV0, NOT SV0, NOT SV0, NOT SV0)) AND (  
			std_logic_vector'( SV1, SV1, SV1, SV1)) AND (  std_logic_vector'( SV2, SV2, 
			SV2, SV2)) AND (  std_logic_vector'( NOT SV3, NOT SV3, NOT SV3, NOT SV3)) AND
			  ( std_logic_vector'("1111") ) AND  (( std_logic_vector'(NOT BP_columna3, 
			NOT BP_columna2, NOT BP_columna1, NOT BP_columna0)) ) ) OR  ((  
			std_logic_vector'( NOT SV0, NOT SV0, NOT SV0, NOT SV0)) AND (  
			std_logic_vector'( SV1, SV1, SV1, SV1)) AND (  std_logic_vector'( NOT SV2, 
			NOT SV2, NOT SV2, NOT SV2)) AND (  std_logic_vector'( NOT SV3, NOT SV3, NOT 
			SV3, NOT SV3)) AND  ( std_logic_vector'("1111") ) AND  (( std_logic_vector'(
			NOT BP_columna3, NOT BP_columna2, NOT BP_columna1, NOT BP_columna0)) -
			std_logic_vector'("0001") ) ) OR  ((  std_logic_vector'( NOT SV0, NOT SV0, 
			NOT SV0, NOT SV0)) AND (  std_logic_vector'( SV1, SV1, SV1, SV1)) AND (  
			std_logic_vector'( SV2, SV2, SV2, SV2)) AND (  std_logic_vector'( SV3, SV3, 
			SV3, SV3)) AND  ((  std_logic_vector'( NOT BP_columna0, NOT BP_columna0, NOT 
			BP_columna0, NOT BP_columna0)) OR (  std_logic_vector'( NOT BP_columna1, NOT 
			BP_columna1, NOT BP_columna1, NOT BP_columna1)) OR (  std_logic_vector'( NOT 
			BP_columna2, NOT BP_columna2, NOT BP_columna2, NOT BP_columna2)) OR (  
			std_logic_vector'( NOT BP_columna3, NOT BP_columna3, NOT BP_columna3, NOT 
			BP_columna3)) ) AND  (( std_logic_vector'(NOT BP_columna3, NOT BP_columna2, 
			NOT BP_columna1, NOT BP_columna0)) ) ) OR  ((  std_logic_vector'( NOT SV0, 
			NOT SV0, NOT SV0, NOT SV0)) AND (  std_logic_vector'( SV1, SV1, SV1, SV1)) 
			AND (  std_logic_vector'( SV2, SV2, SV2, SV2)) AND (  std_logic_vector'( SV3,
			 SV3, SV3, SV3)) AND  ((  std_logic_vector'( BP_columna0, BP_columna0, 
			BP_columna0, BP_columna0)AND  std_logic_vector'( BP_columna1, BP_columna1, 
			BP_columna1, BP_columna1)AND  std_logic_vector'( BP_columna2, BP_columna2, 
			BP_columna2, BP_columna2)AND  std_logic_vector'( BP_columna3, BP_columna3, 
			BP_columna3, BP_columna3)) ) AND  (( std_logic_vector'(NOT BP_columna3, NOT 
			BP_columna2, NOT BP_columna1, NOT BP_columna0)) ) ) OR  ((  std_logic_vector'
			( NOT SV0, NOT SV0, NOT SV0, NOT SV0)) AND (  std_logic_vector'( NOT SV1, NOT
			 SV1, NOT SV1, NOT SV1)) AND (  std_logic_vector'( NOT SV2, NOT SV2, NOT SV2,
			 NOT SV2)) AND (  std_logic_vector'( SV3, SV3, SV3, SV3)) AND  ( 
			std_logic_vector'("1111") ) AND  (std_logic_vector'("1000") ) ) OR  ((  
			std_logic_vector'( SV0, SV0, SV0, SV0)) AND (  std_logic_vector'( NOT SV1, 
			NOT SV1, NOT SV1, NOT SV1)) AND (  std_logic_vector'( NOT SV2, NOT SV2, NOT 
			SV2, NOT SV2)) AND (  std_logic_vector'( NOT SV3, NOT SV3, NOT SV3, NOT SV3))
			 AND  ((  std_logic_vector'( empieza_a_llamar, empieza_a_llamar, 
			empieza_a_llamar, empieza_a_llamar)) ) AND  (std_logic_vector'("1000") ) ) OR
			  ((  std_logic_vector'( SV0, SV0, SV0, SV0)) AND (  std_logic_vector'( NOT 
			SV1, NOT SV1, NOT SV1, NOT SV1)) AND (  std_logic_vector'( NOT SV2, NOT SV2, 
			NOT SV2, NOT SV2)) AND (  std_logic_vector'( NOT SV3, NOT SV3, NOT SV3, NOT 
			SV3)) AND  ((  std_logic_vector'( NOT empieza_a_llamar, NOT empieza_a_llamar,
			 NOT empieza_a_llamar, NOT empieza_a_llamar)) ) AND  (( std_logic_vector'(NOT
			 BP_columna3, NOT BP_columna2, NOT BP_columna1, NOT BP_columna0)) ) );

		IF (( BP_columna0='1' AND BP_columna1='1' AND BP_columna2='1' AND 
			BP_columna3='1' AND SV0='0' AND SV1='1' AND SV2='1' AND SV3='1' ) OR ( 
			BP_fin_llamada='1' AND SV0='0' AND SV1='0' AND SV2='1' ) OR ( 
			BP_fin_llamada='1' AND SV0='0' AND SV1='1' AND SV2='0' ) OR ( 
			BP_fin_llamada='1' AND SV0='0' AND SV3='0' ) OR ( BP_fin_llamada='1' AND 
			BP_columna0='0' AND SV0='0' AND SV2='1' ) OR ( BP_fin_llamada='1' AND 
			BP_columna1='0' AND SV0='0' AND SV2='1' ) OR ( BP_fin_llamada='1' AND 
			BP_columna2='0' AND SV0='0' AND SV2='1' ) OR ( BP_fin_llamada='1' AND 
			BP_columna3='0' AND SV0='0' AND SV2='1' ) OR ( BP_fin_llamada='1' AND 
			empieza_a_llamar='0' AND SV1='0' AND SV2='0' AND SV3='0' )) THEN 
			next_BP_fin_llamada<='1';
		ELSE next_BP_fin_llamada<='0';
		END IF;

		IF (( SV0='0' AND SV1='0' AND SV2='0' AND SV3='0' ) OR ( pulsos3='1' AND 
			SV0='0' AND SV1='0' AND SV3='0' ) OR ( pulsos2='1' AND SV0='0' AND SV1='0' 
			AND SV3='0' ) OR ( pulsos1='1' AND SV0='0' AND SV1='0' AND SV3='0' ) OR ( 
			pulsos0='1' AND SV0='0' AND SV1='0' AND SV3='0' ) OR ( BP_senyal='1' AND 
			SV0='0' AND SV2='0' ) OR ( BP_senyal='1' AND SV0='0' AND SV3='0' ) OR ( 
			BP_senyal='1' AND SV0='0' AND SV1='1' ) OR ( BP_senyal='1' AND SV1='0' AND 
			SV2='0' AND SV3='0' )) THEN next_BP_senyal<='1';
		ELSE next_BP_senyal<='0';
		END IF;

		pulsos<= ((  std_logic_vector'( NOT SV0, NOT SV0, NOT SV0, NOT SV0)) AND ( 
			 std_logic_vector'( SV1, SV1, SV1, SV1)) AND (  std_logic_vector'( SV2, SV2, 
			SV2, SV2)) AND (  std_logic_vector'( SV3, SV3, SV3, SV3)) AND  ((  
			std_logic_vector'( NOT BP_columna0, NOT BP_columna0, NOT BP_columna0, NOT 
			BP_columna0)) OR (  std_logic_vector'( NOT BP_columna1, NOT BP_columna1, NOT 
			BP_columna1, NOT BP_columna1)) OR (  std_logic_vector'( NOT BP_columna2, NOT 
			BP_columna2, NOT BP_columna2, NOT BP_columna2)) OR (  std_logic_vector'( NOT 
			BP_columna3, NOT BP_columna3, NOT BP_columna3, NOT BP_columna3)) ) AND  (( 
			std_logic_vector'(cifra_mem3, cifra_mem2, cifra_mem1, cifra_mem0)) +
			std_logic_vector'("0001") ) ) OR  ((  std_logic_vector'( SV0, SV0, SV0, SV0))
			 AND (  std_logic_vector'( NOT SV1, NOT SV1, NOT SV1, NOT SV1)) AND (  
			std_logic_vector'( NOT SV2, NOT SV2, NOT SV2, NOT SV2)) AND (  
			std_logic_vector'( NOT SV3, NOT SV3, NOT SV3, NOT SV3)) AND  ((  
			std_logic_vector'( NOT empieza_a_llamar, NOT empieza_a_llamar, NOT 
			empieza_a_llamar, NOT empieza_a_llamar)) ) AND  (( std_logic_vector'(
			cifra_mem3, cifra_mem2, cifra_mem1, cifra_mem0)) +std_logic_vector'("0001") )
			 ) OR  ((  std_logic_vector'( NOT SV0, NOT SV0, NOT SV0, NOT SV0)) AND (  
			std_logic_vector'( NOT SV1, NOT SV1, NOT SV1, NOT SV1)) AND (  
			std_logic_vector'( NOT SV2, NOT SV2, NOT SV2, NOT SV2)) AND (  
			std_logic_vector'( SV3, SV3, SV3, SV3)) AND  ( std_logic_vector'("1111") ) 
			AND  (( std_logic_vector'(pulsos3, pulsos2, pulsos1, pulsos0)) ) ) OR  ((  
			std_logic_vector'( NOT SV0, NOT SV0, NOT SV0, NOT SV0)) AND (  
			std_logic_vector'( NOT SV1, NOT SV1, NOT SV1, NOT SV1)) AND (  
			std_logic_vector'( SV2, SV2, SV2, SV2)) AND (  std_logic_vector'( NOT SV3, 
			NOT SV3, NOT SV3, NOT SV3)) AND  ((  std_logic_vector'( NOT pulsos0, NOT 
			pulsos0, NOT pulsos0, NOT pulsos0)AND  std_logic_vector'( NOT pulsos1, NOT 
			pulsos1, NOT pulsos1, NOT pulsos1)AND  std_logic_vector'( NOT pulsos2, NOT 
			pulsos2, NOT pulsos2, NOT pulsos2)AND  std_logic_vector'( NOT pulsos3, NOT 
			pulsos3, NOT pulsos3, NOT pulsos3)) ) AND  (( std_logic_vector'(pulsos3, 
			pulsos2, pulsos1, pulsos0)) ) ) OR  ((  std_logic_vector'( NOT SV0, NOT SV0, 
			NOT SV0, NOT SV0)) AND (  std_logic_vector'( NOT SV1, NOT SV1, NOT SV1, NOT 
			SV1)) AND (  std_logic_vector'( NOT SV2, NOT SV2, NOT SV2, NOT SV2)) AND (  
			std_logic_vector'( NOT SV3, NOT SV3, NOT SV3, NOT SV3)) AND  ( 
			std_logic_vector'("1111") ) AND  (( std_logic_vector'(pulsos3, pulsos2, 
			pulsos1, pulsos0)) -std_logic_vector'("0001") ) ) OR  ((  std_logic_vector'( 
			NOT SV0, NOT SV0, NOT SV0, NOT SV0)) AND (  std_logic_vector'( NOT SV1, NOT 
			SV1, NOT SV1, NOT SV1)) AND (  std_logic_vector'( SV2, SV2, SV2, SV2)) AND ( 
			 std_logic_vector'( NOT SV3, NOT SV3, NOT SV3, NOT SV3)) AND  ((  
			std_logic_vector'( pulsos0, pulsos0, pulsos0, pulsos0)) OR (  
			std_logic_vector'( pulsos1, pulsos1, pulsos1, pulsos1)) OR (  
			std_logic_vector'( pulsos2, pulsos2, pulsos2, pulsos2)) OR (  
			std_logic_vector'( pulsos3, pulsos3, pulsos3, pulsos3)) ) AND  (( 
			std_logic_vector'(pulsos3, pulsos2, pulsos1, pulsos0)) -std_logic_vector'(
			"0001") ) ) OR  ((  std_logic_vector'( NOT SV0, NOT SV0, NOT SV0, NOT SV0)) 
			AND (  std_logic_vector'( NOT SV1, NOT SV1, NOT SV1, NOT SV1)) AND (  
			std_logic_vector'( SV2, SV2, SV2, SV2)) AND (  std_logic_vector'( SV3, SV3, 
			SV3, SV3)) AND  ( std_logic_vector'("1111") ) AND  (( std_logic_vector'(
			pulsos3, pulsos2, pulsos1, pulsos0)) ) ) OR  ((  std_logic_vector'( NOT SV0, 
			NOT SV0, NOT SV0, NOT SV0)) AND (  std_logic_vector'( SV1, SV1, SV1, SV1)) 
			AND (  std_logic_vector'( NOT SV2, NOT SV2, NOT SV2, NOT SV2)) AND (  
			std_logic_vector'( NOT SV3, NOT SV3, NOT SV3, NOT SV3)) AND  ( 
			std_logic_vector'("1111") ) AND  (( std_logic_vector'(pulsos3, pulsos2, 
			pulsos1, pulsos0)) ) ) OR  ((  std_logic_vector'( NOT SV0, NOT SV0, NOT SV0, 
			NOT SV0)) AND (  std_logic_vector'( SV1, SV1, SV1, SV1)) AND (  
			std_logic_vector'( NOT SV2, NOT SV2, NOT SV2, NOT SV2)) AND (  
			std_logic_vector'( SV3, SV3, SV3, SV3)) AND  ( std_logic_vector'("1111") ) 
			AND  (( std_logic_vector'(pulsos3, pulsos2, pulsos1, pulsos0)) ) ) OR  ((  
			std_logic_vector'( NOT SV0, NOT SV0, NOT SV0, NOT SV0)) AND (  
			std_logic_vector'( SV1, SV1, SV1, SV1)) AND (  std_logic_vector'( SV2, SV2, 
			SV2, SV2)) AND (  std_logic_vector'( NOT SV3, NOT SV3, NOT SV3, NOT SV3)) AND
			  ( std_logic_vector'("1111") ) AND  (( std_logic_vector'(pulsos3, pulsos2, 
			pulsos1, pulsos0)) ) ) OR  ((  std_logic_vector'( NOT SV0, NOT SV0, NOT SV0, 
			NOT SV0)) AND (  std_logic_vector'( SV1, SV1, SV1, SV1)) AND (  
			std_logic_vector'( SV2, SV2, SV2, SV2)) AND (  std_logic_vector'( SV3, SV3, 
			SV3, SV3)) AND  ((  std_logic_vector'( BP_columna0, BP_columna0, BP_columna0,
			 BP_columna0)AND  std_logic_vector'( BP_columna1, BP_columna1, BP_columna1, 
			BP_columna1)AND  std_logic_vector'( BP_columna2, BP_columna2, BP_columna2, 
			BP_columna2)AND  std_logic_vector'( BP_columna3, BP_columna3, BP_columna3, 
			BP_columna3)) ) AND  (( std_logic_vector'(pulsos3, pulsos2, pulsos1, pulsos0)
			) ) ) OR  ((  std_logic_vector'( SV0, SV0, SV0, SV0)) AND (  
			std_logic_vector'( NOT SV1, NOT SV1, NOT SV1, NOT SV1)) AND (  
			std_logic_vector'( NOT SV2, NOT SV2, NOT SV2, NOT SV2)) AND (  
			std_logic_vector'( NOT SV3, NOT SV3, NOT SV3, NOT SV3)) AND  ((  
			std_logic_vector'( empieza_a_llamar, empieza_a_llamar, empieza_a_llamar, 
			empieza_a_llamar)) ) AND  (( std_logic_vector'(pulsos3, pulsos2, pulsos1, 
			pulsos0)) ) );

		next_BP_columna3 <= NOT (BP_columna(3));
		next_BP_columna2 <= NOT (BP_columna(2));
		next_BP_columna1 <= NOT (BP_columna(1));
		next_BP_columna0 <= NOT (BP_columna(0));
		next_pulsos3 <= pulsos(3);
		next_pulsos2 <= pulsos(2);
		next_pulsos1 <= pulsos(1);
		next_pulsos0 <= pulsos(0);
	END PROCESS;

	PROCESS (BP_fin_llamada)
	BEGIN
		IF (( BP_fin_llamada='1' )) THEN fin_llamada<='1';
		ELSE fin_llamada<='0';
		END IF;
	END PROCESS;

	PROCESS (BP_senyal)
	BEGIN
		IF (( BP_senyal='1' )) THEN senyal<='1';
		ELSE senyal<='0';
		END IF;
	END PROCESS;

	PROCESS (BP_columna0,BP_columna1,BP_columna2,BP_columna3,columna)
	BEGIN
		columna <= (( std_logic_vector'(NOT BP_columna3, NOT BP_columna2, NOT 
			BP_columna1, NOT BP_columna0)));
		columna0 <= NOT (columna(0));
		columna1 <= NOT (columna(1));
		columna2 <= NOT (columna(2));
		columna3 <= NOT (columna(3));
	END PROCESS;
END BEHAVIOR;

LIBRARY ieee;
USE ieee.std_logic_1164.all;

LIBRARY ieee;
USE ieee.std_logic_unsigned.all;

ENTITY LLAMADAS IS
	PORT (cifra_mem : IN std_logic_vector (3 DOWNTO 0);
		columna : OUT std_logic_vector (3 DOWNTO 0);
		CLK,empieza_a_llamar,RESET: IN std_logic;
		fin_llamada,senyal : OUT std_logic);
END;

ARCHITECTURE BEHAVIOR OF LLAMADAS IS
	COMPONENT SHELL_LLAMADAS
		PORT (CLK,cifra_mem0,cifra_mem1,cifra_mem2,cifra_mem3,empieza_a_llamar,
			RESET: IN std_logic;
			columna0,columna1,columna2,columna3,fin_llamada,senyal : OUT std_logic);
	END COMPONENT;
BEGIN
	SHELL1_LLAMADAS : SHELL_LLAMADAS PORT MAP (CLK=>CLK,cifra_mem0=>cifra_mem(0)
		,cifra_mem1=>cifra_mem(1),cifra_mem2=>cifra_mem(2),cifra_mem3=>cifra_mem(3),
		empieza_a_llamar=>empieza_a_llamar,RESET=>RESET,columna0=>columna(0),columna1
		=>columna(1),columna2=>columna(2),columna3=>columna(3),fin_llamada=>
		fin_llamada,senyal=>senyal);
END BEHAVIOR;
