--  C:\08ABR_10H\NUCLEO.vhd
--  VHDL code created by Xilinx's StateCAD 6.2i
--  Fri Apr 08 12:23:47 2005

--  This VHDL code (for use with Xilinx XST) was generated using: 
--  one-hot state assignment with boolean code format.
--  Minimization is enabled,  implied else is enabled, 
--  and outputs are speed optimized.

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY SHELL_NUCLEO IS
	PORT (CLK,AAT,AP,DA,fin_llamada,M1,M2,PP,RESET,SA,SF,SG,TOFF: IN std_logic;
		empieza_a_llamar,LED1,LED2,T1ON,T2ON,TIPO_CALL0,TIPO_CALL1 : BUFFER 
			std_logic);
END;

ARCHITECTURE BEHAVIOR OF SHELL_NUCLEO IS
--	State variables for machine sreg
	SIGNAL AL2_SELECT, next_AL2_SELECT, ESPERA, next_ESPERA, M2_REAL, 
		next_M2_REAL, M2_T1, next_M2_T1, M2_T2, next_M2_T2, M_1, next_M_1, NAGUA, 
		next_NAGUA, NFOC, next_NFOC, NGAS, next_NGAS, NROB, next_NROB, PARAR_LLAMADAS
		, next_PARAR_LLAMADAS, SEL_M1_M2, next_SEL_M1_M2 : std_logic;
	SIGNAL next_empieza_a_llamar,next_LED1,next_LED2,next_T1ON,next_T2ON,
		next_TIPO_CALL0,next_TIPO_CALL1 : std_logic;
	SIGNAL TIPO_CALL : std_logic_vector (1 DOWNTO 0);
BEGIN
	PROCESS (CLK, next_AL2_SELECT, next_ESPERA, next_M2_REAL, next_M2_T1, 
		next_M2_T2, next_M_1, next_NAGUA, next_NFOC, next_NGAS, next_NROB, 
		next_PARAR_LLAMADAS, next_SEL_M1_M2, next_empieza_a_llamar, next_LED1, 
		next_LED2, next_T1ON, next_T2ON, next_TIPO_CALL1, next_TIPO_CALL0)
	BEGIN
		IF CLK='1' AND CLK'event THEN
			AL2_SELECT <= next_AL2_SELECT;
			ESPERA <= next_ESPERA;
			M2_REAL <= next_M2_REAL;
			M2_T1 <= next_M2_T1;
			M2_T2 <= next_M2_T2;
			M_1 <= next_M_1;
			NAGUA <= next_NAGUA;
			NFOC <= next_NFOC;
			NGAS <= next_NGAS;
			NROB <= next_NROB;
			PARAR_LLAMADAS <= next_PARAR_LLAMADAS;
			SEL_M1_M2 <= next_SEL_M1_M2;
			empieza_a_llamar <= next_empieza_a_llamar;
			LED1 <= next_LED1;
			LED2 <= next_LED2;
			T1ON <= next_T1ON;
			T2ON <= next_T2ON;
			TIPO_CALL1 <= next_TIPO_CALL1;
			TIPO_CALL0 <= next_TIPO_CALL0;
		END IF;
	END PROCESS;

	PROCESS (AAT,AL2_SELECT,AP,DA,empieza_a_llamar,ESPERA,fin_llamada,LED1,LED2,
		M1,M2,M2_REAL,M2_T1,M2_T2,M_1,NAGUA,NFOC,NGAS,NROB,PARAR_LLAMADAS,PP,RESET,SA
		,SEL_M1_M2,SF,SG,T1ON,T2ON,TIPO_CALL0,TIPO_CALL1,TOFF,TIPO_CALL)
	BEGIN

		IF (( AAT='1' AND DA='1' AND RESET='0' AND  (AL2_SELECT='1')) OR ( 
			RESET='0' AND AAT='0' AND DA='0' AND  (AL2_SELECT='1')) OR ( RESET='0' AND 
			TOFF='1' AND  (M2_T2='1')) OR ( RESET='0' AND AAT='1' AND M2='0' AND DA='0' 
			AND  (M_1='1'))) THEN next_AL2_SELECT<='1';
		ELSE next_AL2_SELECT<='0';
		END IF;

		IF (( AAT='1' AND DA='1' AND RESET='0' AND  (ESPERA='1')) OR ( RESET='0' 
			AND AAT='0' AND DA='0' AND  (ESPERA='1')) OR ( RESET='0' AND fin_llamada='1' 
			AND  (NAGUA='1')) OR ( RESET='0' AND fin_llamada='1' AND  (NFOC='1')) OR ( 
			RESET='0' AND fin_llamada='1' AND  (NGAS='1'))) THEN next_ESPERA<='1';
		ELSE next_ESPERA<='0';
		END IF;

		IF (( PP='0' AND AP='0' AND SG='1' AND SA='1' AND RESET='0' AND  (
			M2_REAL='1')) OR ( PP='0' AND AP='0' AND SG='1' AND SF='1' AND RESET='0' AND 
			 (M2_REAL='1')) OR ( PP='0' AND AP='0' AND SA='1' AND SF='1' AND RESET='0' 
			AND  (M2_REAL='1')) OR ( RESET='0' AND SF='0' AND SG='0' AND SA='0' AND 
			PP='0' AND AP='0' AND  (M2_REAL='1')) OR ( RESET='0' AND TOFF='1' AND  (
			M2_T1='1'))) THEN next_M2_REAL<='1';
		ELSE next_M2_REAL<='0';
		END IF;

		IF (( RESET='0' AND DA='0' AND TOFF='0' AND  (M2_T1='1')) OR ( RESET='0' 
			AND M2='1' AND AAT='0' AND DA='0' AND  (M_1='1')) OR ( RESET='0' AND M2='1' 
			AND M1='0' AND  (SEL_M1_M2='1'))) THEN next_M2_T1<='1';
		ELSE next_M2_T1<='0';
		END IF;

		IF (( RESET='0' AND PP='1' AND AP='0' AND  (M2_REAL='1')) OR ( RESET='0' 
			AND DA='0' AND TOFF='0' AND  (M2_T2='1'))) THEN next_M2_T2<='1';
		ELSE next_M2_T2<='0';
		END IF;

		IF (( RESET='0' AND DA='1' AND TOFF='0' AND  (M2_T2='1')) OR ( DA='0' AND 
			M2='0' AND SF='1' AND AAT='0' AND SA='1' AND RESET='0' AND  (M_1='1')) OR ( 
			DA='0' AND M2='0' AND SF='1' AND AAT='0' AND SG='1' AND RESET='0' AND  (
			M_1='1')) OR ( DA='0' AND M2='0' AND AAT='0' AND SA='1' AND SG='1' AND 
			RESET='0' AND  (M_1='1')) OR ( M2='1' AND DA='1' AND RESET='0' AND  (M_1='1')
			) OR ( AAT='1' AND DA='1' AND RESET='0' AND  (M_1='1')) OR ( AAT='1' AND 
			M2='1' AND RESET='0' AND  (M_1='1')) OR ( RESET='0' AND M2='0' AND AAT='0' 
			AND DA='0' AND SF='0' AND SG='0' AND SA='0' AND  (M_1='1')) OR ( RESET='0' 
			AND M1='1' AND M2='0' AND  (SEL_M1_M2='1'))) THEN next_M_1<='1';
		ELSE next_M_1<='0';
		END IF;

		IF (( RESET='0' AND SF='0' AND SG='0' AND SA='1' AND PP='0' AND AP='0' AND 
			 (M2_REAL='1')) OR ( RESET='0' AND AAT='0' AND DA='0' AND SF='0' AND SG='0' 
			AND SA='1' AND M2='0' AND  (M_1='1')) OR ( RESET='0' AND fin_llamada='0' AND 
			 (NAGUA='1'))) THEN next_NAGUA<='1';
		ELSE next_NAGUA<='0';
		END IF;

		IF (( RESET='0' AND SF='1' AND SG='0' AND SA='0' AND PP='0' AND AP='0' AND 
			 (M2_REAL='1')) OR ( RESET='0' AND AAT='0' AND DA='0' AND SF='1' AND SG='0' 
			AND SA='0' AND M2='0' AND  (M_1='1')) OR ( RESET='0' AND fin_llamada='0' AND 
			 (NFOC='1'))) THEN next_NFOC<='1';
		ELSE next_NFOC<='0';
		END IF;

		IF (( RESET='0' AND SF='0' AND SG='1' AND SA='0' AND PP='0' AND AP='0' AND 
			 (M2_REAL='1')) OR ( RESET='0' AND AAT='0' AND DA='0' AND SF='0' AND SG='1' 
			AND SA='0' AND M2='0' AND  (M_1='1')) OR ( RESET='0' AND fin_llamada='0' AND 
			 (NGAS='1'))) THEN next_NGAS<='1';
		ELSE next_NGAS<='0';
		END IF;

		IF (( RESET='0' AND AAT='1' AND DA='0' AND  (AL2_SELECT='1')) OR ( 
			RESET='0' AND AAT='1' AND DA='0' AND  (ESPERA='1')) OR ( RESET='0' AND AP='1'
			 AND  (M2_REAL='1')) OR ( RESET='0' AND fin_llamada='0' AND  (NROB='1'))) 
			THEN next_NROB<='1';
		ELSE next_NROB<='0';
		END IF;

		IF (( RESET='0' AND fin_llamada='1' AND  (NROB='1'))) THEN 
			next_PARAR_LLAMADAS<='1';
		ELSE next_PARAR_LLAMADAS<='0';
		END IF;

		IF (( AAT='0' AND DA='1' AND  (AL2_SELECT='1')) OR ( AAT='0' AND DA='1' AND
			  (ESPERA='1')) OR ( DA='1' AND TOFF='0' AND  (M2_T1='1')) OR ( DA='1' AND 
			M2='0' AND AAT='0' AND  (M_1='1')) OR (  (PARAR_LLAMADAS='1')) OR ( M2='1' 
			AND M1='1' AND  (SEL_M1_M2='1')) OR ( M1='0' AND M2='0' AND  (SEL_M1_M2='1'))
			 OR ( RESET='1' )) THEN next_SEL_M1_M2<='1';
		ELSE next_SEL_M1_M2<='0';
		END IF;


		IF (( empieza_a_llamar='1' AND RESET='0' AND DA='1' AND  (AL2_SELECT='1')) 
			OR ( empieza_a_llamar='1' AND RESET='0' AND AAT='0' AND  (AL2_SELECT='1')) OR
			 ( empieza_a_llamar='1' AND RESET='0' AND AAT='0' AND DA='1' AND  (ESPERA='1'
			)) OR ( empieza_a_llamar='1' AND SA='1' AND SF='1' AND RESET='0' AND  (
			M2_REAL='1')) OR ( empieza_a_llamar='1' AND SG='1' AND SF='1' AND RESET='0' 
			AND  (M2_REAL='1')) OR ( empieza_a_llamar='1' AND SG='1' AND SA='1' AND 
			RESET='0' AND  (M2_REAL='1')) OR ( empieza_a_llamar='1' AND RESET='0' AND 
			PP='1' AND  (M2_REAL='1')) OR ( empieza_a_llamar='1' AND RESET='0' AND SF='0'
			 AND SG='0' AND SA='0' AND  (M2_REAL='1')) OR ( empieza_a_llamar='1' AND 
			RESET='0' AND  (M2_T1='1')) OR ( empieza_a_llamar='1' AND RESET='0' AND  (
			M2_T2='1')) OR ( empieza_a_llamar='1' AND SA='1' AND SG='1' AND RESET='0' AND
			  (M_1='1')) OR ( empieza_a_llamar='1' AND SF='1' AND SG='1' AND RESET='0' 
			AND  (M_1='1')) OR ( empieza_a_llamar='1' AND SF='1' AND SA='1' AND RESET='0'
			 AND  (M_1='1')) OR ( empieza_a_llamar='1' AND RESET='0' AND DA='1' AND  (
			M_1='1')) OR ( empieza_a_llamar='1' AND RESET='0' AND M2='1' AND  (M_1='1')) 
			OR ( empieza_a_llamar='1' AND RESET='0' AND SF='0' AND SG='0' AND SA='0' AND 
			 (M_1='1')) OR ( empieza_a_llamar='1' AND RESET='0' AND AAT='1' AND  (M_1='1'
			)) OR ( RESET='0' AND SF='0' AND SG='0' AND SA='1' AND PP='0' AND  (
			M2_REAL='1')) OR ( RESET='0' AND AAT='0' AND DA='0' AND SF='0' AND SG='0' AND
			 SA='1' AND M2='0' AND  (M_1='1')) OR ( RESET='0' AND fin_llamada='0' AND  (
			NAGUA='1')) OR ( RESET='0' AND SF='1' AND SG='0' AND SA='0' AND PP='0' AND  (
			M2_REAL='1')) OR ( RESET='0' AND AAT='0' AND DA='0' AND SF='1' AND SG='0' AND
			 SA='0' AND M2='0' AND  (M_1='1')) OR ( RESET='0' AND fin_llamada='0' AND  (
			NFOC='1')) OR ( RESET='0' AND SF='0' AND SG='1' AND SA='0' AND PP='0' AND  (
			M2_REAL='1')) OR ( RESET='0' AND AAT='0' AND DA='0' AND SF='0' AND SG='1' AND
			 SA='0' AND M2='0' AND  (M_1='1')) OR ( RESET='0' AND fin_llamada='0' AND  (
			NGAS='1')) OR ( RESET='0' AND AAT='1' AND DA='0' AND  (AL2_SELECT='1')) OR ( 
			RESET='0' AND AAT='1' AND DA='0' AND  (ESPERA='1')) OR ( RESET='0' AND AP='1'
			 AND  (M2_REAL='1')) OR ( RESET='0' AND fin_llamada='0' AND  (NROB='1')) OR (
			 empieza_a_llamar='1' AND RESET='0' AND  (PARAR_LLAMADAS='1')) OR ( 
			empieza_a_llamar='1' AND RESET='0' AND  (SEL_M1_M2='1'))) THEN 
			next_empieza_a_llamar<='1';
		ELSE next_empieza_a_llamar<='0';
		END IF;

		IF (( LED1='1' AND RESET='0' AND DA='0' AND  (AL2_SELECT='1')) OR ( 
			LED1='1' AND RESET='0' AND AAT='1' AND  (AL2_SELECT='1')) OR ( AAT='1' AND 
			DA='1' AND RESET='0' AND  (ESPERA='1')) OR ( RESET='0' AND AAT='0' AND DA='0'
			 AND  (ESPERA='1')) OR ( RESET='0' AND fin_llamada='1' AND  (NAGUA='1')) OR (
			 RESET='0' AND fin_llamada='1' AND  (NFOC='1')) OR ( RESET='0' AND 
			fin_llamada='1' AND  (NGAS='1')) OR ( LED1='1' AND RESET='0' AND AAT='1' AND 
			 (ESPERA='1')) OR ( LED1='1' AND RESET='0' AND  (M2_REAL='1')) OR ( LED1='1' 
			AND RESET='0' AND TOFF='1' AND  (M2_T1='1')) OR ( LED1='1' AND RESET='0' AND 
			DA='0' AND  (M2_T1='1')) OR ( LED1='1' AND RESET='0' AND  (M2_T2='1')) OR ( 
			LED1='1' AND RESET='0' AND M2='1' AND  (M_1='1')) OR ( LED1='1' AND RESET='0'
			 AND AAT='1' AND  (M_1='1')) OR ( LED1='1' AND RESET='0' AND DA='0' AND  (
			M_1='1')) OR ( LED1='1' AND RESET='0' AND  (NAGUA='1')) OR ( LED1='1' AND 
			RESET='0' AND  (NFOC='1')) OR ( LED1='1' AND RESET='0' AND  (NGAS='1')) OR ( 
			LED1='1' AND RESET='0' AND  (NROB='1')) OR ( LED1='1' AND RESET='0' AND 
			M1='1' AND M2='0' AND  (SEL_M1_M2='1')) OR ( LED1='1' AND RESET='0' AND 
			M2='1' AND M1='0' AND  (SEL_M1_M2='1'))) THEN next_LED1<='1';
		ELSE next_LED1<='0';
		END IF;

		IF (( AAT='1' AND DA='1' AND RESET='0' AND  (AL2_SELECT='1')) OR ( 
			RESET='0' AND AAT='0' AND DA='0' AND  (AL2_SELECT='1')) OR ( RESET='0' AND 
			TOFF='1' AND  (M2_T2='1')) OR ( RESET='0' AND AAT='1' AND M2='0' AND DA='0' 
			AND  (M_1='1')) OR ( LED2='1' AND RESET='0' AND AAT='1' AND  (AL2_SELECT='1')
			) OR ( LED2='1' AND RESET='0' AND DA='0' AND  (ESPERA='1')) OR ( LED2='1' AND
			 RESET='0' AND AAT='1' AND  (ESPERA='1')) OR ( LED2='1' AND RESET='0' AND  (
			M2_REAL='1')) OR ( LED2='1' AND RESET='0' AND TOFF='1' AND  (M2_T1='1')) OR (
			 LED2='1' AND RESET='0' AND DA='0' AND  (M2_T1='1')) OR ( LED2='1' AND 
			RESET='0' AND  (M2_T2='1')) OR ( LED2='1' AND AAT='1' AND RESET='0' AND  (
			M_1='1')) OR ( LED2='1' AND RESET='0' AND M2='1' AND  (M_1='1')) OR ( 
			LED2='1' AND RESET='0' AND DA='0' AND  (M_1='1')) OR ( LED2='1' AND RESET='0'
			 AND  (NAGUA='1')) OR ( LED2='1' AND RESET='0' AND  (NFOC='1')) OR ( LED2='1'
			 AND RESET='0' AND  (NGAS='1')) OR ( LED2='1' AND RESET='0' AND  (NROB='1')) 
			OR ( LED2='1' AND RESET='0' AND M1='1' AND M2='0' AND  (SEL_M1_M2='1')) OR ( 
			LED2='1' AND RESET='0' AND M2='1' AND M1='0' AND  (SEL_M1_M2='1'))) THEN 
			next_LED2<='1';
		ELSE next_LED2<='0';
		END IF;

		IF (( T1ON='1' AND RESET='0' AND DA='0' AND  (AL2_SELECT='1')) OR ( 
			T1ON='1' AND RESET='0' AND AAT='1' AND  (AL2_SELECT='1')) OR ( T1ON='1' AND 
			RESET='0' AND DA='0' AND  (ESPERA='1')) OR ( T1ON='1' AND RESET='0' AND 
			AAT='1' AND  (ESPERA='1')) OR ( T1ON='1' AND RESET='0' AND PP='1' AND  (
			M2_REAL='1')) OR ( T1ON='1' AND RESET='0' AND AP='1' AND  (M2_REAL='1')) OR (
			 T1ON='1' AND RESET='0' AND SF='1' AND SG='0' AND SA='0' AND  (M2_REAL='1')) 
			OR ( T1ON='1' AND RESET='0' AND SF='0' AND SG='0' AND SA='1' AND  (
			M2_REAL='1')) OR ( T1ON='1' AND RESET='0' AND SF='0' AND SG='1' AND SA='0' 
			AND  (M2_REAL='1')) OR ( RESET='0' AND DA='0' AND TOFF='0' AND  (M2_T1='1')) 
			OR ( RESET='0' AND M2='1' AND AAT='0' AND DA='0' AND  (M_1='1')) OR ( 
			RESET='0' AND M2='1' AND M1='0' AND  (SEL_M1_M2='1')) OR ( T1ON='1' AND 
			RESET='0' AND  (M2_T2='1')) OR ( T1ON='1' AND M2='1' AND RESET='0' AND  (
			M_1='1')) OR ( T1ON='1' AND RESET='0' AND AAT='1' AND  (M_1='1')) OR ( 
			T1ON='1' AND RESET='0' AND DA='0' AND  (M_1='1')) OR ( T1ON='1' AND RESET='0'
			 AND  (NAGUA='1')) OR ( T1ON='1' AND RESET='0' AND  (NFOC='1')) OR ( T1ON='1'
			 AND RESET='0' AND  (NGAS='1')) OR ( T1ON='1' AND RESET='0' AND  (NROB='1')) 
			OR ( T1ON='1' AND RESET='0' AND M1='1' AND M2='0' AND  (SEL_M1_M2='1'))) THEN
			 next_T1ON<='1';
		ELSE next_T1ON<='0';
		END IF;

		IF (( T2ON='1' AND RESET='0' AND AAT='0' AND DA='1' AND  (AL2_SELECT='1')) 
			OR ( T2ON='1' AND RESET='0' AND AAT='1' AND DA='0' AND  (AL2_SELECT='1')) OR 
			( T2ON='1' AND RESET='0' AND  (ESPERA='1')) OR ( T2ON='1' AND RESET='0' AND 
			AP='1' AND  (M2_REAL='1')) OR ( T2ON='1' AND RESET='0' AND PP='0' AND  (
			M2_REAL='1')) OR ( T2ON='1' AND RESET='0' AND  (M2_T1='1')) OR ( RESET='0' 
			AND PP='1' AND AP='0' AND  (M2_REAL='1')) OR ( RESET='0' AND DA='0' AND 
			TOFF='0' AND  (M2_T2='1')) OR ( T2ON='1' AND RESET='0' AND DA='1' AND M2='0' 
			AND AAT='0' AND  (M_1='1')) OR ( T2ON='1' AND RESET='0' AND M2='1' AND 
			AAT='0' AND DA='0' AND  (M_1='1')) OR ( T2ON='1' AND RESET='0' AND AAT='0' 
			AND SF='0' AND SG='1' AND SA='0' AND M2='0' AND  (M_1='1')) OR ( T2ON='1' AND
			 RESET='0' AND AAT='0' AND SF='0' AND SG='0' AND SA='1' AND M2='0' AND  (
			M_1='1')) OR ( T2ON='1' AND RESET='0' AND AAT='0' AND SF='1' AND SG='0' AND 
			SA='0' AND M2='0' AND  (M_1='1')) OR ( T2ON='1' AND RESET='0' AND  (NAGUA='1'
			)) OR ( T2ON='1' AND RESET='0' AND  (NFOC='1')) OR ( T2ON='1' AND RESET='0' 
			AND  (NGAS='1')) OR ( T2ON='1' AND RESET='0' AND  (NROB='1')) OR ( T2ON='1' 
			AND RESET='0' AND  (PARAR_LLAMADAS='1')) OR ( T2ON='1' AND RESET='0' AND 
			M2='1' AND  (SEL_M1_M2='1')) OR ( T2ON='1' AND RESET='0' AND M1='0' AND  (
			SEL_M1_M2='1'))) THEN next_T2ON<='1';
		ELSE next_T2ON<='0';
		END IF;

		TIPO_CALL<= ((  std_logic_vector'( AL2_SELECT, AL2_SELECT)) AND  ((  
			std_logic_vector'( AAT, AAT)AND  std_logic_vector'( DA, DA)AND  
			std_logic_vector'( NOT RESET, NOT RESET)) ) AND  (( std_logic_vector'(
			TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  std_logic_vector'( AL2_SELECT, 
			AL2_SELECT)) AND  ((  std_logic_vector'( NOT RESET, NOT RESET)AND  
			std_logic_vector'( NOT AAT, NOT AAT)AND  std_logic_vector'( DA, DA)) ) AND  (
			( std_logic_vector'(TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  std_logic_vector'( 
			AL2_SELECT, AL2_SELECT)) AND  ((  std_logic_vector'( NOT RESET, NOT RESET)AND
			  std_logic_vector'( NOT AAT, NOT AAT)AND  std_logic_vector'( NOT DA, NOT DA)
			) ) AND  (( std_logic_vector'(TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  
			std_logic_vector'( ESPERA, ESPERA)) AND  ((  std_logic_vector'( AAT, AAT)AND 
			 std_logic_vector'( DA, DA)AND  std_logic_vector'( NOT RESET, NOT RESET)) ) 
			AND  (( std_logic_vector'(TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  
			std_logic_vector'( ESPERA, ESPERA)) AND  ((  std_logic_vector'( NOT RESET, 
			NOT RESET)AND  std_logic_vector'( NOT AAT, NOT AAT)AND  std_logic_vector'( DA
			, DA)) ) AND  (( std_logic_vector'(TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  
			std_logic_vector'( ESPERA, ESPERA)) AND  ((  std_logic_vector'( NOT RESET, 
			NOT RESET)AND  std_logic_vector'( NOT AAT, NOT AAT)AND  std_logic_vector'( 
			NOT DA, NOT DA)) ) AND  (( std_logic_vector'(TIPO_CALL1, TIPO_CALL0)) ) ) OR 
			 ((  std_logic_vector'( M2_REAL, M2_REAL)) AND  ((  std_logic_vector'( NOT PP
			, NOT PP)AND  std_logic_vector'( NOT AP, NOT AP)AND  std_logic_vector'( SA, 
			SA)AND  std_logic_vector'( SF, SF)AND  std_logic_vector'( NOT RESET, NOT 
			RESET)) OR (  std_logic_vector'( NOT PP, NOT PP)AND  std_logic_vector'( NOT 
			AP, NOT AP)AND  std_logic_vector'( SG, SG)AND  std_logic_vector'( SF, SF)AND 
			 std_logic_vector'( NOT RESET, NOT RESET)) OR (  std_logic_vector'( NOT PP, 
			NOT PP)AND  std_logic_vector'( NOT AP, NOT AP)AND  std_logic_vector'( SG, SG)
			AND  std_logic_vector'( SA, SA)AND  std_logic_vector'( NOT RESET, NOT RESET))
			 ) AND  (( std_logic_vector'(TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  
			std_logic_vector'( M2_REAL, M2_REAL)) AND  ((  std_logic_vector'( NOT RESET, 
			NOT RESET)AND  std_logic_vector'( PP, PP)AND  std_logic_vector'( NOT AP, NOT 
			AP)) ) AND  (( std_logic_vector'(TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  
			std_logic_vector'( M2_REAL, M2_REAL)) AND  ((  std_logic_vector'( NOT RESET, 
			NOT RESET)AND  std_logic_vector'( NOT SF, NOT SF)AND  std_logic_vector'( NOT 
			SG, NOT SG)AND  std_logic_vector'( NOT SA, NOT SA)AND  std_logic_vector'( NOT
			 PP, NOT PP)AND  std_logic_vector'( NOT AP, NOT AP)) ) AND  (( 
			std_logic_vector'(TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  std_logic_vector'( 
			M2_T1, M2_T1)) AND  ((  std_logic_vector'( NOT RESET, NOT RESET)AND  
			std_logic_vector'( TOFF, TOFF)) ) AND  (( std_logic_vector'(TIPO_CALL1, 
			TIPO_CALL0)) ) ) OR  ((  std_logic_vector'( M2_T1, M2_T1)) AND  ((  
			std_logic_vector'( NOT RESET, NOT RESET)AND  std_logic_vector'( DA, DA)AND  
			std_logic_vector'( NOT TOFF, NOT TOFF)) ) AND  (( std_logic_vector'(
			TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  std_logic_vector'( M2_T1, M2_T1)) AND  (
			(  std_logic_vector'( NOT RESET, NOT RESET)AND  std_logic_vector'( NOT DA, 
			NOT DA)AND  std_logic_vector'( NOT TOFF, NOT TOFF)) ) AND  (( 
			std_logic_vector'(TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  std_logic_vector'( 
			M2_T2, M2_T2)) AND  ((  std_logic_vector'( NOT RESET, NOT RESET)AND  
			std_logic_vector'( NOT DA, NOT DA)AND  std_logic_vector'( NOT TOFF, NOT TOFF)
			) ) AND  (( std_logic_vector'(TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  
			std_logic_vector'( M2_T2, M2_T2)) AND  ((  std_logic_vector'( NOT RESET, NOT 
			RESET)AND  std_logic_vector'( DA, DA)AND  std_logic_vector'( NOT TOFF, NOT 
			TOFF)) ) AND  (( std_logic_vector'(TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  
			std_logic_vector'( M2_T2, M2_T2)) AND  ((  std_logic_vector'( NOT RESET, NOT 
			RESET)AND  std_logic_vector'( TOFF, TOFF)) ) AND  (( std_logic_vector'(
			TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  std_logic_vector'( M_1, M_1)) AND  ((  
			std_logic_vector'( AAT, AAT)AND  std_logic_vector'( M2, M2)AND  
			std_logic_vector'( NOT RESET, NOT RESET)) OR (  std_logic_vector'( AAT, AAT)
			AND  std_logic_vector'( DA, DA)AND  std_logic_vector'( NOT RESET, NOT RESET))
			 OR (  std_logic_vector'( M2, M2)AND  std_logic_vector'( DA, DA)AND  
			std_logic_vector'( NOT RESET, NOT RESET)) OR (  std_logic_vector'( NOT DA, 
			NOT DA)AND  std_logic_vector'( NOT M2, NOT M2)AND  std_logic_vector'( NOT AAT
			, NOT AAT)AND  std_logic_vector'( SA, SA)AND  std_logic_vector'( SG, SG)AND  
			std_logic_vector'( NOT RESET, NOT RESET)) OR (  std_logic_vector'( NOT DA, 
			NOT DA)AND  std_logic_vector'( NOT M2, NOT M2)AND  std_logic_vector'( SF, SF)
			AND  std_logic_vector'( NOT AAT, NOT AAT)AND  std_logic_vector'( SG, SG)AND  
			std_logic_vector'( NOT RESET, NOT RESET)) OR (  std_logic_vector'( NOT DA, 
			NOT DA)AND  std_logic_vector'( NOT M2, NOT M2)AND  std_logic_vector'( SF, SF)
			AND  std_logic_vector'( NOT AAT, NOT AAT)AND  std_logic_vector'( SA, SA)AND  
			std_logic_vector'( NOT RESET, NOT RESET)) ) AND  (( std_logic_vector'(
			TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  std_logic_vector'( M_1, M_1)) AND  ((  
			std_logic_vector'( NOT RESET, NOT RESET)AND  std_logic_vector'( DA, DA)AND  
			std_logic_vector'( NOT M2, NOT M2)AND  std_logic_vector'( NOT AAT, NOT AAT)) 
			) AND  (( std_logic_vector'(TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  
			std_logic_vector'( M_1, M_1)) AND  ((  std_logic_vector'( NOT RESET, NOT 
			RESET)AND  std_logic_vector'( M2, M2)AND  std_logic_vector'( NOT AAT, NOT AAT
			)AND  std_logic_vector'( NOT DA, NOT DA)) ) AND  (( std_logic_vector'(
			TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  std_logic_vector'( M_1, M_1)) AND  ((  
			std_logic_vector'( NOT RESET, NOT RESET)AND  std_logic_vector'( NOT M2, NOT 
			M2)AND  std_logic_vector'( NOT AAT, NOT AAT)AND  std_logic_vector'( NOT DA, 
			NOT DA)AND  std_logic_vector'( NOT SF, NOT SF)AND  std_logic_vector'( NOT SG,
			 NOT SG)AND  std_logic_vector'( NOT SA, NOT SA)) ) AND  (( std_logic_vector'(
			TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  std_logic_vector'( M_1, M_1)) AND  ((  
			std_logic_vector'( NOT RESET, NOT RESET)AND  std_logic_vector'( AAT, AAT)AND 
			 std_logic_vector'( NOT M2, NOT M2)AND  std_logic_vector'( NOT DA, NOT DA)) )
			 AND  (( std_logic_vector'(TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  
			std_logic_vector'( M2_REAL, M2_REAL)) AND  ((  std_logic_vector'( NOT RESET, 
			NOT RESET)AND  std_logic_vector'( NOT SF, NOT SF)AND  std_logic_vector'( NOT 
			SG, NOT SG)AND  std_logic_vector'( SA, SA)AND  std_logic_vector'( NOT PP, NOT
			 PP)AND  std_logic_vector'( NOT AP, NOT AP)) ) AND  (std_logic_vector'("10") 
			) ) OR  ((  std_logic_vector'( M_1, M_1)) AND  ((  std_logic_vector'( NOT 
			RESET, NOT RESET)AND  std_logic_vector'( NOT AAT, NOT AAT)AND  
			std_logic_vector'( NOT DA, NOT DA)AND  std_logic_vector'( NOT SF, NOT SF)AND 
			 std_logic_vector'( NOT SG, NOT SG)AND  std_logic_vector'( SA, SA)AND  
			std_logic_vector'( NOT M2, NOT M2)) ) AND  (std_logic_vector'("10") ) ) OR  (
			(  std_logic_vector'( NAGUA, NAGUA)) AND  ((  std_logic_vector'( NOT RESET, 
			NOT RESET)AND  std_logic_vector'( NOT fin_llamada, NOT fin_llamada)) ) AND  (
			std_logic_vector'("10") ) ) OR  ((  std_logic_vector'( NAGUA, NAGUA)) AND  ((
			  std_logic_vector'( NOT RESET, NOT RESET)AND  std_logic_vector'( fin_llamada
			, fin_llamada)) ) AND  (( std_logic_vector'(TIPO_CALL1, TIPO_CALL0)) ) ) OR  
			((  std_logic_vector'( M2_REAL, M2_REAL)) AND  ((  std_logic_vector'( NOT 
			RESET, NOT RESET)AND  std_logic_vector'( SF, SF)AND  std_logic_vector'( NOT 
			SG, NOT SG)AND  std_logic_vector'( NOT SA, NOT SA)AND  std_logic_vector'( NOT
			 PP, NOT PP)AND  std_logic_vector'( NOT AP, NOT AP)) ) AND  (
			std_logic_vector'("00") ) ) OR  ((  std_logic_vector'( M_1, M_1)) AND  ((  
			std_logic_vector'( NOT RESET, NOT RESET)AND  std_logic_vector'( NOT AAT, NOT 
			AAT)AND  std_logic_vector'( NOT DA, NOT DA)AND  std_logic_vector'( SF, SF)AND
			  std_logic_vector'( NOT SG, NOT SG)AND  std_logic_vector'( NOT SA, NOT SA)
			AND  std_logic_vector'( NOT M2, NOT M2)) ) AND  (std_logic_vector'("00") ) ) 
			OR  ((  std_logic_vector'( NFOC, NFOC)) AND  ((  std_logic_vector'( NOT RESET
			, NOT RESET)AND  std_logic_vector'( NOT fin_llamada, NOT fin_llamada)) ) AND 
			 (std_logic_vector'("00") ) ) OR  ((  std_logic_vector'( NFOC, NFOC)) AND  ((
			  std_logic_vector'( NOT RESET, NOT RESET)AND  std_logic_vector'( fin_llamada
			, fin_llamada)) ) AND  (( std_logic_vector'(TIPO_CALL1, TIPO_CALL0)) ) ) OR  
			((  std_logic_vector'( M2_REAL, M2_REAL)) AND  ((  std_logic_vector'( NOT 
			RESET, NOT RESET)AND  std_logic_vector'( NOT SF, NOT SF)AND  
			std_logic_vector'( SG, SG)AND  std_logic_vector'( NOT SA, NOT SA)AND  
			std_logic_vector'( NOT PP, NOT PP)AND  std_logic_vector'( NOT AP, NOT AP)) ) 
			AND  (std_logic_vector'("01") ) ) OR  ((  std_logic_vector'( M_1, M_1)) AND  
			((  std_logic_vector'( NOT RESET, NOT RESET)AND  std_logic_vector'( NOT AAT, 
			NOT AAT)AND  std_logic_vector'( NOT DA, NOT DA)AND  std_logic_vector'( NOT SF
			, NOT SF)AND  std_logic_vector'( SG, SG)AND  std_logic_vector'( NOT SA, NOT 
			SA)AND  std_logic_vector'( NOT M2, NOT M2)) ) AND  (std_logic_vector'("01") )
			 ) OR  ((  std_logic_vector'( NGAS, NGAS)) AND  ((  std_logic_vector'( NOT 
			RESET, NOT RESET)AND  std_logic_vector'( NOT fin_llamada, NOT fin_llamada)) )
			 AND  (std_logic_vector'("01") ) ) OR  ((  std_logic_vector'( NGAS, NGAS)) 
			AND  ((  std_logic_vector'( NOT RESET, NOT RESET)AND  std_logic_vector'( 
			fin_llamada, fin_llamada)) ) AND  (( std_logic_vector'(TIPO_CALL1, TIPO_CALL0
			)) ) ) OR  ((  std_logic_vector'( AL2_SELECT, AL2_SELECT)) AND  ((  
			std_logic_vector'( NOT RESET, NOT RESET)AND  std_logic_vector'( AAT, AAT)AND 
			 std_logic_vector'( NOT DA, NOT DA)) ) AND  (std_logic_vector'("11") ) ) OR  
			((  std_logic_vector'( ESPERA, ESPERA)) AND  ((  std_logic_vector'( NOT RESET
			, NOT RESET)AND  std_logic_vector'( AAT, AAT)AND  std_logic_vector'( NOT DA, 
			NOT DA)) ) AND  (std_logic_vector'("11") ) ) OR  ((  std_logic_vector'( 
			M2_REAL, M2_REAL)) AND  ((  std_logic_vector'( NOT RESET, NOT RESET)AND  
			std_logic_vector'( AP, AP)) ) AND  (std_logic_vector'("11") ) ) OR  ((  
			std_logic_vector'( NROB, NROB)) AND  ((  std_logic_vector'( NOT RESET, NOT 
			RESET)AND  std_logic_vector'( NOT fin_llamada, NOT fin_llamada)) ) AND  (
			std_logic_vector'("11") ) ) OR  ((  std_logic_vector'( NROB, NROB)) AND  ((  
			std_logic_vector'( NOT RESET, NOT RESET)AND  std_logic_vector'( fin_llamada, 
			fin_llamada)) ) AND  (( std_logic_vector'(TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((
			  std_logic_vector'( PARAR_LLAMADAS, PARAR_LLAMADAS)) AND  ((  
			std_logic_vector'( NOT RESET, NOT RESET)) ) AND  (( std_logic_vector'(
			TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  std_logic_vector'( SEL_M1_M2, SEL_M1_M2)
			) AND  ((  std_logic_vector'( M2, M2)AND  std_logic_vector'( M1, M1)AND  
			std_logic_vector'( NOT RESET, NOT RESET)) ) AND  (( std_logic_vector'(
			TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  std_logic_vector'( SEL_M1_M2, SEL_M1_M2)
			) AND  ((  std_logic_vector'( NOT RESET, NOT RESET)AND  std_logic_vector'( M1
			, M1)AND  std_logic_vector'( NOT M2, NOT M2)) ) AND  (( std_logic_vector'(
			TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  std_logic_vector'( SEL_M1_M2, SEL_M1_M2)
			) AND  ((  std_logic_vector'( NOT RESET, NOT RESET)AND  std_logic_vector'( M2
			, M2)AND  std_logic_vector'( NOT M1, NOT M1)) ) AND  (( std_logic_vector'(
			TIPO_CALL1, TIPO_CALL0)) ) ) OR  ((  std_logic_vector'( SEL_M1_M2, SEL_M1_M2)
			) AND  ((  std_logic_vector'( NOT RESET, NOT RESET)AND  std_logic_vector'( 
			NOT M1, NOT M1)AND  std_logic_vector'( NOT M2, NOT M2)) ) AND  (( 
			std_logic_vector'(TIPO_CALL1, TIPO_CALL0)) ) ) OR  ( ((  std_logic_vector'( 
			RESET, RESET)) ) AND  (std_logic_vector'("00") ) );

		next_TIPO_CALL1 <= TIPO_CALL(1);
		next_TIPO_CALL0 <= TIPO_CALL(0);
	END PROCESS;
END BEHAVIOR;

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY NUCLEO IS
	PORT (TIPO_CALL : BUFFER std_logic_vector (1 DOWNTO 0);
		CLK,AAT,AP,DA,fin_llamada,M1,M2,PP,RESET,SA,SF,SG,TOFF: IN std_logic;
		empieza_a_llamar,LED1,LED2,T1ON,T2ON : BUFFER std_logic);
END;

ARCHITECTURE BEHAVIOR OF NUCLEO IS
	COMPONENT SHELL_NUCLEO
		PORT (CLK,AAT,AP,DA,fin_llamada,M1,M2,PP,RESET,SA,SF,SG,TOFF: IN std_logic;
			empieza_a_llamar,LED1,LED2,T1ON,T2ON,TIPO_CALL0,TIPO_CALL1 : BUFFER 
				std_logic);
	END COMPONENT;
BEGIN
	SHELL1_NUCLEO : SHELL_NUCLEO PORT MAP (CLK=>CLK,AAT=>AAT,AP=>AP,DA=>DA,
		fin_llamada=>fin_llamada,M1=>M1,M2=>M2,PP=>PP,RESET=>RESET,SA=>SA,SF=>SF,SG=>
		SG,TOFF=>TOFF,empieza_a_llamar=>empieza_a_llamar,LED1=>LED1,LED2=>LED2,T1ON=>
		T1ON,T2ON=>T2ON,TIPO_CALL0=>TIPO_CALL(0),TIPO_CALL1=>TIPO_CALL(1));
END BEHAVIOR;
