--------------------------------------------------------------------------------
-- Copyright (c) 1995-2003 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 6.3.03i
--  \   \         Application : 
--  /   /         Filename : memoria.vhf
-- /___/   /\     Timestamp : 04/08/2005 13:21:40
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: memoria
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
-- synopsys translate_off
library UNISIM;
use UNISIM.Vcomponents.ALL;
-- synopsys translate_on

entity memoria is
   port ( COLUMNA   : in    std_logic_vector (3 downto 0); 
          TIPO_CALL : in    std_logic_vector (1 downto 0); 
          CIFRA_MEM : out   std_logic_vector (3 downto 0));
end memoria;

architecture BEHAVIORAL of memoria is
   attribute INIT       : string ;
   attribute BOX_TYPE   : string ;
   component ROM64X1
      -- synopsys translate_off
      generic( INIT : bit_vector :=  x"0000000000000000");
      -- synopsys translate_on
      port ( A0 : in    std_logic; 
             A1 : in    std_logic; 
             A2 : in    std_logic; 
             A3 : in    std_logic; 
             A4 : in    std_logic; 
             A5 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute INIT of ROM64X1 : component is "0000000000000000";
   attribute BOX_TYPE of ROM64X1 : component is "BLACK_BOX";
   
   attribute INIT of XLXI_1 : label is "0D80E7807E803000";
   attribute INIT of XLXI_2 : label is "4D80A5005B004D00";
   attribute INIT of XLXI_3 : label is "D4007E00F580D880";
   attribute INIT of XLXI_4 : label is "92000C8080000380";
begin
   XLXI_1 : ROM64X1
   -- synopsys translate_off
   generic map( INIT => x"0D80E7807E803000")
   -- synopsys translate_on
      port map (A0=>COLUMNA(0),      
                A1=>COLUMNA(1),      
                A2=>COLUMNA(2),      
                A3=>COLUMNA(3),      
                A4=>TIPO_CALL(0),      
                A5=>TIPO_CALL(1),      
                O=>CIFRA_MEM(1));
   
   XLXI_2 : ROM64X1
   -- synopsys translate_off
   generic map( INIT => x"4D80A5005B004D00")
   -- synopsys translate_on
      port map (A0=>COLUMNA(0),      
                A1=>COLUMNA(1),      
                A2=>COLUMNA(2),      
                A3=>COLUMNA(3),      
                A4=>TIPO_CALL(0),      
                A5=>TIPO_CALL(1),      
                O=>CIFRA_MEM(2));
   
   XLXI_3 : ROM64X1
   -- synopsys translate_off
   generic map( INIT => x"D4007E00F580D880")
   -- synopsys translate_on
      port map (A0=>COLUMNA(0),      
                A1=>COLUMNA(1),      
                A2=>COLUMNA(2),      
                A3=>COLUMNA(3),      
                A4=>TIPO_CALL(0),      
                A5=>TIPO_CALL(1),      
                O=>CIFRA_MEM(3));
   
   XLXI_4 : ROM64X1
   -- synopsys translate_off
   generic map( INIT => x"92000C8080000380")
   -- synopsys translate_on
      port map (A0=>COLUMNA(0),      
                A1=>COLUMNA(1),      
                A2=>COLUMNA(2),      
                A3=>COLUMNA(3),      
                A4=>TIPO_CALL(0),      
                A5=>TIPO_CALL(1),      
                O=>CIFRA_MEM(0));
   
end BEHAVIORAL;


