library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity timer is
    port (clk : in std_logic;
          t1on : in std_logic;
          t2on : in std_logic;
          end_count : out std_logic);
end entity timer;

architecture behavior of timer is
begin

timer: process (clk,t1on,t2on)
	variable counter : std_logic_vector(7 downto 0); 
begin
   if t1on='1' then 
		counter:="00110011";--variable q cuenta
	elsif t2on='1' then
		counter:="10000000";
	elsif counter=0 then 
		end_count<='1';
	elsif clk'event and clk='1' then
		counter:=counter-1;
	end if;
end process timer;
end architecture behavior;
