VERSION 6
BEGIN SCHEMATIC
    BEGIN ATTR DeviceFamilyName "spartan3"
        DELETE all:0
        EDITNAME all:0
        EDITTRAIT all:0
    END ATTR
    BEGIN NETLIST
        BEGIN SIGNAL TIPO_CALL(1)
        END SIGNAL
        BEGIN SIGNAL TIPO_CALL(0)
        END SIGNAL
        SIGNAL COLUMNA(3)
        SIGNAL COLUMNA(2)
        SIGNAL COLUMNA(1)
        SIGNAL CIFRA_MEM(0)
        SIGNAL CIFRA_MEM(2)
        SIGNAL CIFRA_MEM(3:0)
        SIGNAL CIFRA_MEM(1)
        SIGNAL CIFRA_MEM(3)
        SIGNAL COLUMNA(3:0)
        SIGNAL COLUMNA(0)
        SIGNAL TIPO_CALL(1:0)
        SIGNAL XLXN_2
        PORT Output CIFRA_MEM(3:0)
        PORT Input COLUMNA(3:0)
        PORT Input TIPO_CALL(1:0)
        BEGIN BLOCKDEF rom64x1
            TIMESTAMP 2001 2 9 16 27 15
            RECTANGLE N 64 -448 320 0 
            LINE N 64 -64 0 -64 
            LINE N 384 -384 320 -384 
            LINE N 0 -192 64 -192 
            LINE N 0 -384 64 -384 
            LINE N 0 -320 64 -320 
            LINE N 0 -256 64 -256 
            LINE N 0 -128 64 -128 
        END BLOCKDEF
        BEGIN BLOCK XLXI_2 rom64x1
            BEGIN ATTR INIT "0D80E7807E803000"
                VERILOG all:0 dp:1nosynth wsynop:1 wsynth:1
                VHDL all:0 gm:1nosynth wa:1 wd:1
                VALUETYPE BitVector 64 h
            END ATTR
            PIN A0 COLUMNA(0)
            PIN A1 COLUMNA(1)
            PIN A2 COLUMNA(2)
            PIN A3 COLUMNA(3)
            PIN A4 TIPO_CALL(0)
            PIN A5 TIPO_CALL(1)
            PIN O CIFRA_MEM(1)
        END BLOCK
        BEGIN BLOCK XLXI_3 rom64x1
            BEGIN ATTR INIT "4D80A5005B004D00"
                VERILOG all:0 dp:1nosynth wsynop:1 wsynth:1
                VHDL all:0 gm:1nosynth wa:1 wd:1
                VALUETYPE BitVector 64 h
            END ATTR
            PIN A0 COLUMNA(0)
            PIN A1 COLUMNA(1)
            PIN A2 COLUMNA(2)
            PIN A3 COLUMNA(3)
            PIN A4 TIPO_CALL(0)
            PIN A5 TIPO_CALL(1)
            PIN O CIFRA_MEM(2)
        END BLOCK
        BEGIN BLOCK XLXI_4 rom64x1
            BEGIN ATTR INIT "D4007E00F580D880"
                VERILOG all:0 dp:1nosynth wsynop:1 wsynth:1
                VHDL all:0 gm:1nosynth wa:1 wd:1
                VALUETYPE BitVector 64 h
            END ATTR
            PIN A0 COLUMNA(0)
            PIN A1 COLUMNA(1)
            PIN A2 COLUMNA(2)
            PIN A3 COLUMNA(3)
            PIN A4 TIPO_CALL(0)
            PIN A5 TIPO_CALL(1)
            PIN O CIFRA_MEM(3)
        END BLOCK
        BEGIN BLOCK XLXI_1 rom64x1
            BEGIN ATTR INIT "92000C8080000380"
                VERILOG all:0 dp:1nosynth wsynop:1 wsynth:1
                VHDL all:0 gm:1nosynth wa:1 wd:1
                VALUETYPE BitVector 64 h
            END ATTR
            PIN A0 COLUMNA(0)
            PIN A1 COLUMNA(1)
            PIN A2 COLUMNA(2)
            PIN A3 COLUMNA(3)
            PIN A4 TIPO_CALL(0)
            PIN A5 TIPO_CALL(1)
            PIN O CIFRA_MEM(0)
        END BLOCK
    END NETLIST
    BEGIN SHEET 1 3520 2720
        BEGIN INSTANCE XLXI_2 1264 1296 R0
            BEGIN DISPLAY 0 -520 ATTR INIT
                FONT 28 "Arial"
                DISPLAYFORMAT NAMEEQUALSVALUE
            END DISPLAY
        END INSTANCE
        BEGIN INSTANCE XLXI_3 1264 1824 R0
            BEGIN DISPLAY 0 -520 ATTR INIT
                FONT 28 "Arial"
                DISPLAYFORMAT NAMEEQUALSVALUE
            END DISPLAY
        END INSTANCE
        BEGIN BRANCH TIPO_CALL(1)
            WIRE 320 976 320 1008
            WIRE 320 1008 480 1008
            WIRE 480 720 608 720
            WIRE 608 720 608 1232
            WIRE 608 1232 1264 1232
            WIRE 608 1232 608 1760
            WIRE 608 1760 1264 1760
            WIRE 608 1760 608 2256
            WIRE 608 2256 1264 2256
            WIRE 608 720 1264 720
            WIRE 480 720 480 848
            WIRE 480 848 480 1008
            BEGIN DISPLAY 480 848 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH TIPO_CALL(0)
            WIRE 320 912 336 912
            WIRE 336 864 336 912
            WIRE 336 864 432 864
            WIRE 432 656 752 656
            WIRE 752 656 752 1168
            WIRE 752 1168 1264 1168
            WIRE 752 1168 752 1696
            WIRE 752 1696 1264 1696
            WIRE 752 1696 752 2192
            WIRE 752 2192 1264 2192
            WIRE 752 656 1264 656
            WIRE 432 656 432 752
            WIRE 432 752 432 864
            BEGIN DISPLAY 432 752 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH COLUMNA(3)
            WIRE 256 592 320 592
            WIRE 320 592 848 592
            WIRE 848 592 848 1104
            WIRE 848 1104 1264 1104
            WIRE 848 1104 848 1632
            WIRE 848 1632 1264 1632
            WIRE 848 1632 848 2128
            WIRE 848 2128 1264 2128
            WIRE 848 592 1264 592
            BEGIN DISPLAY 320 592 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH COLUMNA(2)
            WIRE 256 528 320 528
            WIRE 320 528 960 528
            WIRE 960 528 960 1040
            WIRE 960 1040 1264 1040
            WIRE 960 1040 960 1568
            WIRE 960 1568 1264 1568
            WIRE 960 1568 960 2064
            WIRE 960 2064 1264 2064
            WIRE 960 528 1264 528
            BEGIN DISPLAY 320 528 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH COLUMNA(1)
            WIRE 256 464 320 464
            WIRE 320 464 1040 464
            WIRE 1040 464 1040 976
            WIRE 1040 976 1264 976
            WIRE 1040 976 1040 1504
            WIRE 1040 1504 1264 1504
            WIRE 1040 1504 1040 2000
            WIRE 1040 2000 1264 2000
            WIRE 1040 464 1264 464
            BEGIN DISPLAY 320 464 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN INSTANCE XLXI_4 1264 2320 R0
            BEGIN DISPLAY 0 -520 ATTR INIT
                FONT 28 "Arial"
                DISPLAYFORMAT NAMEEQUALSVALUE
            END DISPLAY
        END INSTANCE
        BEGIN BRANCH CIFRA_MEM(3)
            WIRE 1648 1936 1824 1936
            WIRE 1824 1472 1824 1936
            WIRE 1824 1472 1984 1472
            WIRE 1984 1472 2144 1472
            BEGIN DISPLAY 1984 1472 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN INSTANCE XLXI_1 1264 784 R0
            BEGIN DISPLAY 0 -520 ATTR INIT
                FONT 28 "Arial"
                DISPLAYFORMAT NAMEEQUALSVALUE
            END DISPLAY
        END INSTANCE
        BEGIN BRANCH CIFRA_MEM(2)
            WIRE 1648 1440 1888 1440
            WIRE 1888 1392 1888 1440
            WIRE 1888 1392 1984 1392
            WIRE 1984 1392 2144 1392
            BEGIN DISPLAY 1984 1392 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH CIFRA_MEM(3:0)
            WIRE 2416 400 2416 560
            WIRE 2416 560 2416 976
            WIRE 2416 976 2416 1392
            WIRE 2416 1392 2416 1472
            WIRE 2416 976 2480 976
            WIRE 2480 976 2672 976
            BEGIN DISPLAY 2480 976 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH CIFRA_MEM(0)
            WIRE 1648 400 1968 400
            WIRE 1968 400 2224 400
            BEGIN DISPLAY 1968 400 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH CIFRA_MEM(1)
            WIRE 1648 560 1648 912
            WIRE 1648 560 1968 560
            WIRE 1968 560 2080 560
            BEGIN DISPLAY 1968 560 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BUSTAP 2416 560 2080 560
        BUSTAP 2416 400 2224 400
        BUSTAP 2416 1392 2144 1392
        BUSTAP 2416 1472 2144 1472
        IOMARKER 2672 976 CIFRA_MEM(3:0) R0 28
        BEGIN BRANCH COLUMNA(3:0)
            WIRE 80 272 80 480
            WIRE 80 480 160 480
            WIRE 160 480 160 528
            WIRE 160 528 160 592
            WIRE 80 272 224 272
            WIRE 160 400 160 464
            WIRE 160 464 160 480
        END BRANCH
        IOMARKER 224 272 COLUMNA(3:0) R0 28
        BUSTAP 160 400 256 400
        BUSTAP 160 464 256 464
        BUSTAP 160 528 256 528
        BUSTAP 160 592 256 592
        BEGIN BRANCH COLUMNA(0)
            WIRE 256 400 272 400
            WIRE 272 400 320 400
            WIRE 320 400 1136 400
            WIRE 1136 400 1136 912
            WIRE 1136 912 1136 1440
            WIRE 1136 1440 1136 1936
            WIRE 1136 1936 1264 1936
            WIRE 1136 1440 1264 1440
            WIRE 1136 912 1264 912
            WIRE 1136 400 1264 400
            BEGIN DISPLAY 320 400 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH TIPO_CALL(1:0)
            WIRE 48 880 48 944
            WIRE 48 944 96 944
            WIRE 96 944 224 944
            WIRE 224 944 224 976
            WIRE 224 912 224 944
            BEGIN DISPLAY 96 944 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BUSTAP 224 912 320 912
        BUSTAP 224 976 320 976
        IOMARKER 48 880 TIPO_CALL(1:0) R270 28
    END SHEET
END SCHEMATIC
