VERSION 6
BEGIN SCHEMATIC
    BEGIN ATTR DeviceFamilyName "spartan3"
        DELETE all:0
        EDITNAME all:0
        EDITTRAIT all:0
    END ATTR
    BEGIN NETLIST
        SIGNAL TIPO_CALL(1:0)
        SIGNAL XLXN_2(1:0)
        SIGNAL XLXN_3
        SIGNAL TIPO_CALL(1)
        SIGNAL XLXN_5
        SIGNAL TIPO_CALL(0)
        SIGNAL COLUMNA(3)
        SIGNAL COLUMNA(2)
        SIGNAL COLUMNA(1)
        SIGNAL CIFRA_MEM(3)
        SIGNAL CIFRA_MEM(2)
        SIGNAL CIFRA_MEM(3:0)
        SIGNAL CIFRA_MEM(0)
        SIGNAL CIFRA_MEM(1)
        SIGNAL COLUMNA(3:0)
        SIGNAL XLXN_16(3:0)
        SIGNAL COLUMNA(0)
        PORT Input TIPO_CALL(1:0)
        PORT Output CIFRA_MEM(3:0)
        PORT Input COLUMNA(3:0)
        BEGIN BLOCKDEF rom64x1
            TIMESTAMP 2001 2 9 16 27 15
            RECTANGLE N 64 -448 320 0 
            LINE N 64 -64 0 -64 
            LINE N 384 -384 320 -384 
            LINE N 0 -192 64 -192 
            LINE N 0 -384 64 -384 
            LINE N 0 -320 64 -320 
            LINE N 0 -256 64 -256 
            LINE N 0 -128 64 -128 
        END BLOCKDEF
        BEGIN BLOCK XLXI_1 rom64x1
            BEGIN ATTR INIT "0D80E7807E803000"
                VERILOG all:0 dp:1nosynth wsynop:1 wsynth:1
                VHDL all:0 gm:1nosynth wa:1 wd:1
                VALUETYPE BitVector 64 h
            END ATTR
            PIN A0 COLUMNA(0)
            PIN A1 COLUMNA(1)
            PIN A2 COLUMNA(2)
            PIN A3 COLUMNA(3)
            PIN A4 TIPO_CALL(0)
            PIN A5 TIPO_CALL(1)
            PIN O CIFRA_MEM(1)
        END BLOCK
        BEGIN BLOCK XLXI_2 rom64x1
            BEGIN ATTR INIT "4D80A5005B004D00"
                VERILOG all:0 dp:1nosynth wsynop:1 wsynth:1
                VHDL all:0 gm:1nosynth wa:1 wd:1
                VALUETYPE BitVector 64 h
            END ATTR
            PIN A0 COLUMNA(0)
            PIN A1 COLUMNA(1)
            PIN A2 COLUMNA(2)
            PIN A3 COLUMNA(3)
            PIN A4 TIPO_CALL(0)
            PIN A5 TIPO_CALL(1)
            PIN O CIFRA_MEM(2)
        END BLOCK
        BEGIN BLOCK XLXI_3 rom64x1
            BEGIN ATTR INIT "D4007E00F580D880"
                VERILOG all:0 dp:1nosynth wsynop:1 wsynth:1
                VHDL all:0 gm:1nosynth wa:1 wd:1
                VALUETYPE BitVector 64 h
            END ATTR
            PIN A0 COLUMNA(0)
            PIN A1 COLUMNA(1)
            PIN A2 COLUMNA(2)
            PIN A3 COLUMNA(3)
            PIN A4 TIPO_CALL(0)
            PIN A5 TIPO_CALL(1)
            PIN O CIFRA_MEM(3)
        END BLOCK
        BEGIN BLOCK XLXI_4 rom64x1
            BEGIN ATTR INIT "92000C8080000380"
                VERILOG all:0 dp:1nosynth wsynop:1 wsynth:1
                VHDL all:0 gm:1nosynth wa:1 wd:1
                VALUETYPE BitVector 64 h
            END ATTR
            PIN A0 COLUMNA(0)
            PIN A1 COLUMNA(1)
            PIN A2 COLUMNA(2)
            PIN A3 COLUMNA(3)
            PIN A4 TIPO_CALL(0)
            PIN A5 TIPO_CALL(1)
            PIN O CIFRA_MEM(0)
        END BLOCK
    END NETLIST
    BEGIN SHEET 1 3520 2720
        BEGIN BRANCH TIPO_CALL(1:0)
            WIRE 224 944 400 944
            WIRE 224 944 224 992
            WIRE 224 992 224 1008
            WIRE 224 1008 256 1008
            WIRE 256 1008 256 1040
            WIRE 256 1040 624 1040
            WIRE 256 976 624 976
            WIRE 256 976 256 1008
            WIRE 400 912 400 944
            BEGIN DISPLAY 224 992 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        BEGIN INSTANCE XLXI_1 1664 1360 R0
            BEGIN DISPLAY 0 -520 ATTR INIT
                FONT 28 "Arial"
                DISPLAYFORMAT NAMEEQUALSVALUE
            END DISPLAY
        END INSTANCE
        BEGIN INSTANCE XLXI_2 1664 1888 R0
            BEGIN DISPLAY 0 -520 ATTR INIT
                FONT 28 "Arial"
                DISPLAYFORMAT NAMEEQUALSVALUE
            END DISPLAY
        END INSTANCE
        BEGIN BRANCH TIPO_CALL(1)
            WIRE 720 1040 720 1072
            WIRE 720 1072 880 1072
            WIRE 880 784 1008 784
            WIRE 1008 784 1008 1296
            WIRE 1008 1296 1664 1296
            WIRE 1008 1296 1008 1824
            WIRE 1008 1824 1664 1824
            WIRE 1008 1824 1008 2320
            WIRE 1008 2320 1664 2320
            WIRE 1008 784 1664 784
            WIRE 880 784 880 912
            WIRE 880 912 880 1072
            BEGIN DISPLAY 880 912 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH TIPO_CALL(0)
            WIRE 720 976 736 976
            WIRE 736 928 736 976
            WIRE 736 928 832 928
            WIRE 832 720 1152 720
            WIRE 1152 720 1152 1232
            WIRE 1152 1232 1664 1232
            WIRE 1152 1232 1152 1760
            WIRE 1152 1760 1664 1760
            WIRE 1152 1760 1152 2256
            WIRE 1152 2256 1664 2256
            WIRE 1152 720 1664 720
            WIRE 832 720 832 816
            WIRE 832 816 832 928
            BEGIN DISPLAY 832 816 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH COLUMNA(3)
            WIRE 656 656 720 656
            WIRE 720 656 1248 656
            WIRE 1248 656 1248 1168
            WIRE 1248 1168 1664 1168
            WIRE 1248 1168 1248 1696
            WIRE 1248 1696 1664 1696
            WIRE 1248 1696 1248 2192
            WIRE 1248 2192 1664 2192
            WIRE 1248 656 1664 656
            BEGIN DISPLAY 720 656 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH COLUMNA(2)
            WIRE 656 592 720 592
            WIRE 720 592 1360 592
            WIRE 1360 592 1360 1104
            WIRE 1360 1104 1664 1104
            WIRE 1360 1104 1360 1632
            WIRE 1360 1632 1664 1632
            WIRE 1360 1632 1360 2128
            WIRE 1360 2128 1664 2128
            WIRE 1360 592 1664 592
            BEGIN DISPLAY 720 592 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH COLUMNA(1)
            WIRE 656 528 720 528
            WIRE 720 528 1440 528
            WIRE 1440 528 1440 1040
            WIRE 1440 1040 1664 1040
            WIRE 1440 1040 1440 1568
            WIRE 1440 1568 1664 1568
            WIRE 1440 1568 1440 2064
            WIRE 1440 2064 1664 2064
            WIRE 1440 528 1664 528
            BEGIN DISPLAY 720 528 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN INSTANCE XLXI_3 1664 2384 R0
            BEGIN DISPLAY 0 -520 ATTR INIT
                FONT 28 "Arial"
                DISPLAYFORMAT NAMEEQUALSVALUE
            END DISPLAY
        END INSTANCE
        BEGIN BRANCH CIFRA_MEM(3)
            WIRE 2048 2000 2224 2000
            WIRE 2224 1536 2224 2000
            WIRE 2224 1536 2384 1536
            WIRE 2384 1536 2544 1536
            BEGIN DISPLAY 2384 1536 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN INSTANCE XLXI_4 1664 848 R0
            BEGIN DISPLAY 0 -520 ATTR INIT
                FONT 28 "Arial"
                DISPLAYFORMAT NAMEEQUALSVALUE
            END DISPLAY
        END INSTANCE
        BEGIN BRANCH CIFRA_MEM(2)
            WIRE 2048 1504 2288 1504
            WIRE 2288 1456 2288 1504
            WIRE 2288 1456 2384 1456
            WIRE 2384 1456 2544 1456
            BEGIN DISPLAY 2384 1456 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH CIFRA_MEM(3:0)
            WIRE 2816 464 2816 624
            WIRE 2816 624 2816 1040
            WIRE 2816 1040 2816 1456
            WIRE 2816 1456 2816 1536
            WIRE 2816 1040 2880 1040
            WIRE 2880 1040 3072 1040
            BEGIN DISPLAY 2880 1040 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH CIFRA_MEM(0)
            WIRE 2048 464 2368 464
            WIRE 2368 464 2624 464
            BEGIN DISPLAY 2368 464 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH CIFRA_MEM(1)
            WIRE 2048 624 2048 976
            WIRE 2048 624 2368 624
            WIRE 2368 624 2480 624
            BEGIN DISPLAY 2368 624 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BUSTAP 2816 624 2480 624
        BUSTAP 2816 464 2624 464
        BUSTAP 2816 1456 2544 1456
        BUSTAP 2816 1536 2544 1536
        BEGIN BRANCH COLUMNA(3:0)
            WIRE 480 336 480 544
            WIRE 480 544 560 544
            WIRE 560 544 560 592
            WIRE 560 592 560 656
            WIRE 480 336 624 336
            WIRE 560 464 560 528
            WIRE 560 528 560 544
        END BRANCH
        BUSTAP 560 464 656 464
        BUSTAP 560 528 656 528
        BUSTAP 560 592 656 592
        BUSTAP 560 656 656 656
        BEGIN BRANCH COLUMNA(0)
            WIRE 656 464 720 464
            WIRE 720 464 1536 464
            WIRE 1536 464 1536 976
            WIRE 1536 976 1536 1504
            WIRE 1536 1504 1536 2000
            WIRE 1536 2000 1664 2000
            WIRE 1536 1504 1664 1504
            WIRE 1536 976 1664 976
            WIRE 1536 464 1664 464
            BEGIN DISPLAY 720 464 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BUSTAP 624 976 720 976
        BUSTAP 624 1040 720 1040
        IOMARKER 3072 1040 CIFRA_MEM(3:0) R0 28
        IOMARKER 624 336 COLUMNA(3:0) R0 28
        IOMARKER 400 912 TIPO_CALL(1:0) R270 28
    END SHEET
END SCHEMATIC
