VERSION 6
BEGIN SCHEMATIC
    BEGIN ATTR DeviceFamilyName "spartan3"
        DELETE all:0
        EDITNAME all:0
        EDITTRAIT all:0
    END ATTR
    BEGIN NETLIST
        SIGNAL CLK
        SIGNAL XLXN_4
        SIGNAL ent(3:0)
        SIGNAL ent(1)
        SIGNAL ent(2)
        SIGNAL ent(3)
        SIGNAL XLXN_41
        SIGNAL XLXN_42
        SIGNAL ent(0)
        SIGNAL s(6:0)
        SIGNAL s(4)
        SIGNAL s(2)
        SIGNAL s(1)
        SIGNAL s(0)
        SIGNAL s(5)
        SIGNAL s(6)
        SIGNAL A
        SIGNAL B
        SIGNAL C
        SIGNAL D
        SIGNAL E
        SIGNAL F
        SIGNAL G
        SIGNAL s(3)
        SIGNAL tierra_3(3:0)
        SIGNAL tierra_2(3:0)
        SIGNAL tierra(3:0)
        SIGNAL tierra_2(3)
        SIGNAL tierra_2(2)
        SIGNAL tierra_2(1)
        SIGNAL tierra_2(0)
        SIGNAL tierra_3(3)
        SIGNAL tierra_3(2)
        SIGNAL tierra_3(1)
        SIGNAL tierra_3(0)
        SIGNAL tierra(3)
        SIGNAL tierra(2)
        SIGNAL tierra(1)
        SIGNAL tierra(0)
        PORT Input CLK
        PORT Output s(6:0)
        PORT Output A
        PORT Output B
        PORT Output C
        PORT Output D
        PORT Output E
        PORT Output F
        PORT Output G
        BEGIN BLOCKDEF ssegcontrol
            TIMESTAMP 2005 4 8 7 6 56
            RECTANGLE N 64 -320 320 0 
            LINE N 64 -288 0 -288 
            LINE N 64 -224 0 -224 
            RECTANGLE N 0 -236 64 -212 
            LINE N 64 -160 0 -160 
            RECTANGLE N 0 -172 64 -148 
            LINE N 64 -96 0 -96 
            RECTANGLE N 0 -108 64 -84 
            LINE N 64 -32 0 -32 
            RECTANGLE N 0 -44 64 -20 
            LINE N 320 -288 384 -288 
            RECTANGLE N 320 -300 384 -276 
            LINE N 320 -32 384 -32 
            RECTANGLE N 320 -44 384 -20 
        END BLOCKDEF
        BEGIN BLOCKDEF multipleclock
            TIMESTAMP 2005 4 8 7 15 42
            RECTANGLE N 64 -256 320 0 
            LINE N 64 -224 0 -224 
            LINE N 320 -224 384 -224 
            LINE N 320 -160 384 -160 
            LINE N 320 -96 384 -96 
            LINE N 320 -32 384 -32 
        END BLOCKDEF
        BEGIN BLOCKDEF cj4ce
            TIMESTAMP 2001 2 2 12 36 39
            LINE N 384 -320 320 -320 
            LINE N 384 -256 320 -256 
            LINE N 384 -192 320 -192 
            LINE N 384 -128 320 -128 
            LINE N 0 -128 64 -128 
            LINE N 0 -192 64 -192 
            LINE N 0 -32 64 -32 
            LINE N 192 -32 64 -32 
            LINE N 192 -64 192 -32 
            LINE N 80 -128 64 -144 
            LINE N 64 -112 80 -128 
            RECTANGLE N 64 -384 320 -64 
        END BLOCKDEF
        BEGIN BLOCKDEF vcc
            TIMESTAMP 2001 2 2 12 37 29
            LINE N 64 -32 64 -64 
            LINE N 64 0 64 -32 
            LINE N 96 -64 32 -64 
        END BLOCKDEF
        BEGIN BLOCKDEF gnd
            TIMESTAMP 2001 2 2 12 37 29
            LINE N 64 -64 64 -96 
            LINE N 76 -48 52 -48 
            LINE N 68 -32 60 -32 
            LINE N 88 -64 40 -64 
            LINE N 64 -64 64 -80 
            LINE N 64 -128 64 -96 
        END BLOCKDEF
        BEGIN BLOCKDEF buf
            TIMESTAMP 2001 2 2 12 35 54
            LINE N 0 -32 64 -32 
            LINE N 224 -32 128 -32 
            LINE N 64 0 128 -32 
            LINE N 128 -32 64 -64 
            LINE N 64 -64 64 0 
        END BLOCKDEF
        BEGIN BLOCK XLXI_1 ssegcontrol
            PIN CLK XLXN_4
            PIN BCD3(3:0) ent(3:0)
            PIN BCD2(3:0) tierra(3:0)
            PIN BCD1(3:0) tierra_2(3:0)
            PIN BCD0(3:0) tierra_3(3:0)
            PIN DIG(6:0) s(6:0)
            PIN AN(3:0)
        END BLOCK
        BEGIN BLOCK XLXI_2 multipleclock
            PIN clk CLK
            PIN clk25Mhz
            PIN clk50Khz
            PIN clk24hz
            PIN clk1hz XLXN_4
        END BLOCK
        BEGIN BLOCK XLXI_4 cj4ce
            PIN C XLXN_4
            PIN CE XLXN_41
            PIN CLR XLXN_42
            PIN Q0 ent(0)
            PIN Q1 ent(1)
            PIN Q2 ent(2)
            PIN Q3 ent(3)
        END BLOCK
        BEGIN BLOCK XLXI_6 vcc
            PIN P XLXN_41
        END BLOCK
        BEGIN BLOCK XLXI_7 gnd
            PIN G XLXN_42
        END BLOCK
        BEGIN BLOCK XLXI_10 buf
            PIN I s(0)
            PIN O A
        END BLOCK
        BEGIN BLOCK XLXI_9 buf
            PIN I s(1)
            PIN O B
        END BLOCK
        BEGIN BLOCK XLXI_13 buf
            PIN I s(2)
            PIN O C
        END BLOCK
        BEGIN BLOCK XLXI_14 buf
            PIN I s(3)
            PIN O D
        END BLOCK
        BEGIN BLOCK XLXI_15 buf
            PIN I s(4)
            PIN O E
        END BLOCK
        BEGIN BLOCK XLXI_16 buf
            PIN I s(5)
            PIN O F
        END BLOCK
        BEGIN BLOCK XLXI_17 buf
            PIN I s(6)
            PIN O G
        END BLOCK
        BEGIN BLOCK XLXI_64 gnd
            PIN G tierra_2(2)
        END BLOCK
        BEGIN BLOCK XLXI_65 gnd
            PIN G tierra_2(1)
        END BLOCK
        BEGIN BLOCK XLXI_66 gnd
            PIN G tierra_2(0)
        END BLOCK
        BEGIN BLOCK XLXI_67 gnd
            PIN G tierra_2(3)
        END BLOCK
        BEGIN BLOCK XLXI_68 gnd
            PIN G tierra_3(2)
        END BLOCK
        BEGIN BLOCK XLXI_69 gnd
            PIN G tierra_3(1)
        END BLOCK
        BEGIN BLOCK XLXI_70 gnd
            PIN G tierra_3(0)
        END BLOCK
        BEGIN BLOCK XLXI_71 gnd
            PIN G tierra_3(3)
        END BLOCK
        BEGIN BLOCK XLXI_54 gnd
            PIN G tierra(2)
        END BLOCK
        BEGIN BLOCK XLXI_55 gnd
            PIN G tierra(1)
        END BLOCK
        BEGIN BLOCK XLXI_56 gnd
            PIN G tierra(0)
        END BLOCK
        BEGIN BLOCK XLXI_53 gnd
            PIN G tierra(3)
        END BLOCK
    END NETLIST
    BEGIN SHEET 1 3520 2720
        BEGIN BRANCH CLK
            WIRE 1072 432 1088 432
            WIRE 1088 400 1104 400
            WIRE 1088 400 1088 432
        END BRANCH
        IOMARKER 1072 432 CLK R180 28
        BEGIN INSTANCE XLXI_2 1104 624 R0
        END INSTANCE
        BEGIN BRANCH XLXN_4
            WIRE 400 752 400 1216
            WIRE 400 1216 784 1216
            WIRE 400 752 1520 752
            WIRE 1488 592 1520 592
            WIRE 1520 592 1632 592
            WIRE 1520 592 1520 752
        END BRANCH
        BEGIN INSTANCE XLXI_1 1632 880 R0
        END INSTANCE
        BEGIN BRANCH ent(3:0)
            WIRE 1536 656 1568 656
            WIRE 1568 656 1632 656
            WIRE 1536 656 1536 1056
            WIRE 1536 1056 1536 1104
            WIRE 1536 1104 1536 1152
            WIRE 1536 1152 1536 1200
            WIRE 1536 1200 1536 1312
            BEGIN DISPLAY 1568 656 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BUSTAP 1536 1056 1424 1056
        BEGIN BRANCH ent(0)
            WIRE 1168 1024 1296 1024
            WIRE 1296 1024 1408 1024
            WIRE 1408 1024 1408 1056
            WIRE 1408 1056 1424 1056
            BEGIN DISPLAY 1296 1024 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BUSTAP 1536 1104 1440 1104
        BEGIN BRANCH ent(1)
            WIRE 1168 1088 1296 1088
            WIRE 1296 1088 1424 1088
            WIRE 1424 1088 1424 1104
            WIRE 1424 1104 1440 1104
            BEGIN DISPLAY 1296 1088 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BUSTAP 1536 1152 1440 1152
        BEGIN BRANCH ent(2)
            WIRE 1168 1152 1296 1152
            WIRE 1296 1152 1440 1152
            BEGIN DISPLAY 1296 1152 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BUSTAP 1536 1200 1440 1200
        BEGIN BRANCH ent(3)
            WIRE 1168 1216 1296 1216
            WIRE 1296 1216 1424 1216
            WIRE 1424 1200 1440 1200
            WIRE 1424 1200 1424 1216
            BEGIN DISPLAY 1296 1216 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        INSTANCE XLXI_4 784 1344 R0
        INSTANCE XLXI_6 576 1136 R0
        BEGIN BRANCH XLXN_41
            WIRE 640 1136 640 1152
            WIRE 640 1152 784 1152
        END BRANCH
        BEGIN BRANCH XLXN_42
            WIRE 624 1312 784 1312
            WIRE 624 1312 624 1408
        END BRANCH
        INSTANCE XLXI_7 560 1536 R0
        BEGIN BRANCH s(6:0)
            WIRE 2016 592 2048 592
            WIRE 2048 592 2128 592
            WIRE 2128 592 2128 736
            WIRE 2128 736 2128 784
            WIRE 2128 784 2128 832
            WIRE 2128 832 2128 880
            WIRE 2128 880 2128 928
            WIRE 2128 928 2128 1024
            WIRE 2128 1024 2128 1072
            WIRE 2128 1072 2128 1136
            BEGIN DISPLAY 2048 592 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BUSTAP 2128 736 2224 736
        BUSTAP 2128 784 2224 784
        BUSTAP 2128 832 2224 832
        BUSTAP 2128 880 2224 880
        BUSTAP 2128 928 2224 928
        BEGIN BRANCH s(4)
            WIRE 2224 928 2304 928
            WIRE 2304 928 2512 928
            BEGIN DISPLAY 2304 928 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH s(3)
            WIRE 2224 880 2304 880
            WIRE 2304 880 2368 880
            WIRE 2368 864 2512 864
            WIRE 2368 864 2368 880
            BEGIN DISPLAY 2304 880 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH s(2)
            WIRE 2224 832 2304 832
            WIRE 2304 832 2368 832
            WIRE 2368 800 2512 800
            WIRE 2368 800 2368 832
            BEGIN DISPLAY 2304 832 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH s(1)
            WIRE 2224 784 2304 784
            WIRE 2304 784 2432 784
            WIRE 2432 736 2432 784
            WIRE 2432 736 2512 736
            BEGIN DISPLAY 2304 784 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH s(0)
            WIRE 2224 736 2320 736
            WIRE 2320 736 2368 736
            WIRE 2368 672 2368 736
            WIRE 2368 672 2512 672
            BEGIN DISPLAY 2320 736 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BUSTAP 2128 1024 2224 1024
        BEGIN BRANCH s(5)
            WIRE 2224 1024 2304 1024
            WIRE 2304 1024 2368 1024
            WIRE 2368 992 2512 992
            WIRE 2368 992 2368 1024
            BEGIN DISPLAY 2304 1024 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH s(6)
            WIRE 2224 1072 2304 1072
            WIRE 2304 1072 2368 1072
            WIRE 2368 1056 2368 1072
            WIRE 2368 1056 2512 1056
            BEGIN DISPLAY 2304 1072 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        IOMARKER 2928 736 A R0 28
        IOMARKER 2928 784 B R0 28
        IOMARKER 2928 832 C R0 28
        IOMARKER 2928 880 D R0 28
        IOMARKER 2928 928 E R0 28
        IOMARKER 2928 1024 F R0 28
        IOMARKER 2928 1072 G R0 28
        INSTANCE XLXI_10 2512 704 R0
        INSTANCE XLXI_9 2512 768 R0
        INSTANCE XLXI_13 2512 832 R0
        INSTANCE XLXI_14 2512 896 R0
        INSTANCE XLXI_15 2512 960 R0
        INSTANCE XLXI_16 2512 1024 R0
        BEGIN BRANCH A
            WIRE 2736 672 2832 672
            WIRE 2832 672 2832 736
            WIRE 2832 736 2928 736
        END BRANCH
        BEGIN BRANCH B
            WIRE 2736 736 2816 736
            WIRE 2816 736 2816 784
            WIRE 2816 784 2928 784
        END BRANCH
        BEGIN BRANCH C
            WIRE 2736 800 2832 800
            WIRE 2832 800 2832 832
            WIRE 2832 832 2928 832
        END BRANCH
        BEGIN BRANCH D
            WIRE 2736 864 2832 864
            WIRE 2832 864 2832 880
            WIRE 2832 880 2928 880
        END BRANCH
        BEGIN BRANCH E
            WIRE 2736 928 2928 928
        END BRANCH
        BEGIN BRANCH F
            WIRE 2736 992 2832 992
            WIRE 2832 992 2832 1024
            WIRE 2832 1024 2928 1024
        END BRANCH
        BEGIN BRANCH G
            WIRE 2736 1056 2832 1056
            WIRE 2832 1056 2832 1072
            WIRE 2832 1072 2928 1072
        END BRANCH
        INSTANCE XLXI_17 2512 1088 R0
        BUSTAP 2128 1072 2224 1072
        IOMARKER 2128 1136 s(6:0) R90 28
        BEGIN BRANCH tierra_3(3:0)
            WIRE 928 2160 1008 2160
            WIRE 1008 2160 1056 2160
            WIRE 1056 2160 1104 2160
            WIRE 1104 2160 1152 2160
            WIRE 1152 2160 1216 2160
            WIRE 1216 2160 1472 2160
            WIRE 1472 2160 1472 2176
            WIRE 1472 2176 1776 2176
            WIRE 1552 848 1632 848
            WIRE 1552 848 1552 896
            WIRE 1552 896 1776 896
            WIRE 1776 896 1776 2176
            BEGIN DISPLAY 1216 2160 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH tierra_2(3:0)
            WIRE 1472 1904 1552 1904
            WIRE 1552 1904 1600 1904
            WIRE 1600 1904 1648 1904
            WIRE 1648 1904 1696 1904
            WIRE 1696 1904 1728 1904
            WIRE 1584 784 1584 880
            WIRE 1584 880 1712 880
            WIRE 1712 880 1712 992
            WIRE 1712 992 1728 992
            WIRE 1728 992 1728 1760
            WIRE 1728 1760 1728 1904
            WIRE 1584 784 1632 784
            BEGIN DISPLAY 1728 1760 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH tierra(3:0)
            WIRE 736 1696 848 1696
            WIRE 848 1696 896 1696
            WIRE 896 1696 944 1696
            WIRE 944 1696 992 1696
            WIRE 992 1696 1152 1696
            WIRE 1152 1696 1152 1712
            WIRE 1152 1712 1408 1712
            WIRE 1408 1680 1408 1712
            WIRE 1408 1680 1440 1680
            WIRE 1440 1680 1648 1680
            WIRE 1568 720 1568 912
            WIRE 1568 912 1648 912
            WIRE 1648 912 1648 1680
            WIRE 1568 720 1632 720
            BEGIN DISPLAY 1440 1680 ATTR Name
                ALIGNMENT SOFT-BCENTER
            END DISPLAY
        END BRANCH
        BUSTAP 1552 1904 1552 2000
        BUSTAP 1600 1904 1600 2000
        BUSTAP 1648 1904 1648 2000
        BUSTAP 1696 1904 1696 2000
        INSTANCE XLXI_64 1536 2192 R0
        INSTANCE XLXI_65 1584 2208 R0
        BEGIN BRANCH tierra_2(3)
            WIRE 1552 2000 1552 2016
            WIRE 1552 2016 1552 2064
            BEGIN DISPLAY 1552 2016 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH tierra_2(2)
            WIRE 1600 2000 1600 2016
            WIRE 1600 2016 1600 2064
            BEGIN DISPLAY 1600 2016 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH tierra_2(1)
            WIRE 1648 2000 1648 2016
            WIRE 1648 2016 1648 2080
            BEGIN DISPLAY 1648 2016 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH tierra_2(0)
            WIRE 1696 2000 1696 2032
            WIRE 1696 2032 1696 2080
            BEGIN DISPLAY 1696 2032 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        INSTANCE XLXI_66 1632 2208 R0
        INSTANCE XLXI_67 1488 2192 R0
        BUSTAP 1008 2160 1008 2256
        BUSTAP 1056 2160 1056 2256
        BUSTAP 1104 2160 1104 2256
        BUSTAP 1152 2160 1152 2256
        INSTANCE XLXI_68 992 2448 R0
        INSTANCE XLXI_69 1040 2464 R0
        BEGIN BRANCH tierra_3(3)
            WIRE 1008 2256 1008 2272
            WIRE 1008 2272 1008 2320
            BEGIN DISPLAY 1008 2272 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH tierra_3(2)
            WIRE 1056 2256 1056 2272
            WIRE 1056 2272 1056 2320
            BEGIN DISPLAY 1056 2272 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH tierra_3(1)
            WIRE 1104 2256 1104 2272
            WIRE 1104 2272 1104 2336
            BEGIN DISPLAY 1104 2272 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH tierra_3(0)
            WIRE 1152 2256 1152 2288
            WIRE 1152 2288 1152 2336
            BEGIN DISPLAY 1152 2288 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        INSTANCE XLXI_70 1088 2464 R0
        INSTANCE XLXI_71 944 2448 R0
        BUSTAP 848 1696 848 1792
        BUSTAP 896 1696 896 1792
        BUSTAP 944 1696 944 1792
        BUSTAP 992 1696 992 1792
        INSTANCE XLXI_54 832 1984 R0
        INSTANCE XLXI_55 880 2000 R0
        BEGIN BRANCH tierra(3)
            WIRE 848 1792 848 1808
            WIRE 848 1808 848 1856
            BEGIN DISPLAY 848 1808 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH tierra(2)
            WIRE 896 1792 896 1808
            WIRE 896 1808 896 1856
            BEGIN DISPLAY 896 1808 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH tierra(1)
            WIRE 944 1792 944 1808
            WIRE 944 1808 944 1872
            BEGIN DISPLAY 944 1808 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        BEGIN BRANCH tierra(0)
            WIRE 992 1792 992 1824
            WIRE 992 1824 992 1872
            BEGIN DISPLAY 992 1824 ATTR Name
                ALIGNMENT SOFT-TVCENTER
            END DISPLAY
        END BRANCH
        INSTANCE XLXI_56 928 2000 R0
        INSTANCE XLXI_53 784 1984 R0
    END SHEET
END SCHEMATIC
