VERSION 6
BEGIN SCHEMATIC
    BEGIN ATTR DeviceFamilyName "spartan3"
        DELETE all:0
        EDITNAME all:0
        EDITTRAIT all:0
    END ATTR
    BEGIN NETLIST
        SIGNAL CLK_1Hz
        SIGNAL XLXN_93
        SIGNAL XLXN_96
        SIGNAL XLXN_97
        SIGNAL XLXN_98
        SIGNAL XLXN_102
        SIGNAL CLK_50Hz
        SIGNAL XLXN_106
        SIGNAL RESET
        SIGNAL XLXN_112(3:0)
        SIGNAL XLXN_113(3:0)
        SIGNAL XLXN_114(1:0)
        SIGNAL DA
        SIGNAL PP
        SIGNAL SA
        SIGNAL SF
        SIGNAL SG
        SIGNAL LED1
        SIGNAL SENYAL
        SIGNAL LED2
        SIGNAL XLXN_135
        SIGNAL BTN1
        SIGNAL BTN2
        SIGNAL BTN3
        SIGNAL XLXN_147
        SIGNAL XLXN_148
        SIGNAL XLXN_149
        SIGNAL XLXN_150
        SIGNAL AP
        SIGNAL XLXN_153
        SIGNAL XLXN_154
        SIGNAL BTN0
        PORT Input CLK_50Hz
        PORT Input RESET
        PORT Input PP
        PORT Input SA
        PORT Input SF
        PORT Input SG
        PORT Output LED1
        PORT Output SENYAL
        PORT Output LED2
        PORT Input BTN1
        PORT Input BTN2
        PORT Input BTN3
        PORT Input AP
        PORT Input BTN0
        BEGIN BLOCKDEF multipleclock
            TIMESTAMP 2005 4 8 7 15 42
            RECTANGLE N 64 -256 320 0 
            LINE N 64 -224 0 -224 
            LINE N 320 -224 384 -224 
            LINE N 320 -160 384 -160 
            LINE N 320 -96 384 -96 
            LINE N 320 -32 384 -32 
        END BLOCKDEF
        BEGIN BLOCKDEF llamadas
            TIMESTAMP 2005 4 8 15 26 3
            RECTANGLE N 64 -320 320 0 
            LINE N 64 -288 0 -288 
            LINE N 64 -224 0 -224 
            LINE N 64 -160 0 -160 
            LINE N 64 -96 0 -96 
            RECTANGLE N 0 -108 64 -84 
            LINE N 320 -288 384 -288 
            LINE N 320 -160 384 -160 
            LINE N 320 -32 384 -32 
            RECTANGLE N 320 -44 384 -20 
        END BLOCKDEF
        BEGIN BLOCKDEF timer
            TIMESTAMP 2005 4 8 15 35 11
            LINE N 64 32 0 32 
            LINE N 64 -96 0 -96 
            LINE N 64 -32 0 -32 
            LINE N 320 -96 384 -96 
            RECTANGLE N 64 -128 320 128 
        END BLOCKDEF
        BEGIN BLOCKDEF dbounce
            TIMESTAMP 2005 4 8 9 28 57
            RECTANGLE N 64 -128 320 0 
            LINE N 64 -96 0 -96 
            LINE N 64 -32 0 -32 
            LINE N 320 -96 384 -96 
        END BLOCKDEF
        BEGIN BLOCKDEF nucleo
            TIMESTAMP 2005 4 8 10 24 2
            LINE N 320 96 384 96 
            RECTANGLE N 320 84 384 108 
            LINE N 64 32 0 32 
            LINE N 64 -928 0 -928 
            LINE N 64 -864 0 -864 
            LINE N 64 -800 0 -800 
            LINE N 64 -736 0 -736 
            LINE N 64 -672 0 -672 
            LINE N 64 -608 0 -608 
            LINE N 64 -544 0 -544 
            LINE N 64 -480 0 -480 
            LINE N 64 -416 0 -416 
            LINE N 64 -352 0 -352 
            LINE N 64 -288 0 -288 
            LINE N 64 -224 0 -224 
            LINE N 320 -928 384 -928 
            LINE N 320 -704 384 -704 
            LINE N 320 -480 384 -480 
            LINE N 320 -256 384 -256 
            LINE N 320 -32 384 -32 
            RECTANGLE N 64 -960 320 128 
        END BLOCKDEF
        BEGIN BLOCKDEF memoria
            TIMESTAMP 2005 4 8 11 1 55
            RECTANGLE N 64 -128 416 0 
            LINE N 64 -96 0 -96 
            RECTANGLE N 0 -108 64 -84 
            LINE N 64 -32 0 -32 
            RECTANGLE N 0 -44 64 -20 
            LINE N 416 -96 480 -96 
            RECTANGLE N 416 -108 480 -84 
        END BLOCKDEF
        BEGIN BLOCKDEF acceso
            TIMESTAMP 2005 4 8 12 48 49
            RECTANGLE N 64 -448 320 0 
            LINE N 64 -416 0 -416 
            LINE N 64 -352 0 -352 
            LINE N 64 -288 0 -288 
            LINE N 64 -224 0 -224 
            LINE N 64 -160 0 -160 
            LINE N 64 -32 0 -32 
            LINE N 320 -416 384 -416 
            LINE N 320 -288 384 -288 
            LINE N 320 -160 384 -160 
            LINE N 320 -32 384 -32 
        END BLOCKDEF
        BEGIN BLOCK XLXI_13 multipleclock
            PIN clk CLK_50Hz
            PIN clk25Mhz
            PIN clk50Khz
            PIN clk24hz XLXN_135
            PIN clk1hz CLK_1Hz
        END BLOCK
        BEGIN BLOCK XLXI_41 llamadas
            PIN CLK XLXN_135
            PIN empieza_a_llamar XLXN_98
            PIN RESET RESET
            PIN cifra_mem(3:0) XLXN_112(3:0)
            PIN fin_llamada XLXN_106
            PIN senyal SENYAL
            PIN columna(3:0) XLXN_113(3:0)
        END BLOCK
        BEGIN BLOCK XLXI_47 nucleo
            PIN CLK CLK_50Hz
            PIN AAT XLXN_93
            PIN AP AP
            PIN DA DA
            PIN fin_llamada XLXN_106
            PIN M1 XLXN_153
            PIN M2 XLXN_154
            PIN PP PP
            PIN RESET RESET
            PIN SA SA
            PIN SF SF
            PIN SG SG
            PIN TOFF XLXN_102
            PIN empieza_a_llamar XLXN_98
            PIN LED1 LED1
            PIN LED2 LED2
            PIN T1ON XLXN_97
            PIN T2ON XLXN_96
            PIN TIPO_CALL(1:0) XLXN_114(1:0)
        END BLOCK
        BEGIN BLOCK XLXI_48 timer
            PIN CLK CLK_1Hz
            PIN T1ON XLXN_97
            PIN T2ON XLXN_96
            PIN FIN_CUENTA XLXN_102
        END BLOCK
        BEGIN BLOCK XLXI_49 memoria
            PIN TIPO_CALL(1:0) XLXN_114(1:0)
            PIN COLUMNA(3:0) XLXN_113(3:0)
            PIN CIFRA_MEM(3:0) XLXN_112(3:0)
        END BLOCK
        BEGIN BLOCK XLXI_44 dbounce
            PIN clk CLK_1Hz
            PIN key BTN0
            PIN pulse XLXN_147
        END BLOCK
        BEGIN BLOCK XLXI_55 acceso
            PIN CLK CLK_1Hz
            PIN BTN0 XLXN_147
            PIN BTN1 XLXN_148
            PIN BTN2 XLXN_149
            PIN BTN3 XLXN_150
            PIN RESET RESET
            PIN AAT XLXN_93
            PIN DA DA
            PIN M1 XLXN_153
            PIN M2 XLXN_154
        END BLOCK
        BEGIN BLOCK XLXI_45 dbounce
            PIN clk CLK_1Hz
            PIN key BTN1
            PIN pulse XLXN_148
        END BLOCK
        BEGIN BLOCK XLXI_43 dbounce
            PIN clk CLK_1Hz
            PIN key BTN3
            PIN pulse XLXN_150
        END BLOCK
        BEGIN BLOCK XLXI_46 dbounce
            PIN clk CLK_1Hz
            PIN key BTN2
            PIN pulse XLXN_149
        END BLOCK
    END NETLIST
    BEGIN SHEET 1 3520 2720
        BEGIN INSTANCE XLXI_13 256 688 R0
        END INSTANCE
        IOMARKER 192 464 CLK_50Hz R180 28
        BEGIN INSTANCE XLXI_41 3024 1120 R0
        END INSTANCE
        BEGIN INSTANCE XLXI_48 2240 1136 R0
        END INSTANCE
        BEGIN BRANCH XLXN_96
            WIRE 1808 1696 2016 1696
            WIRE 2016 1104 2016 1696
            WIRE 2016 1104 2240 1104
        END BRANCH
        BEGIN BRANCH XLXN_97
            WIRE 1808 1472 2000 1472
            WIRE 2000 1040 2000 1472
            WIRE 2000 1040 2240 1040
        END BRANCH
        BEGIN BRANCH XLXN_98
            WIRE 1808 800 2416 800
            WIRE 2416 800 2416 896
            WIRE 2416 896 3024 896
        END BRANCH
        BEGIN BRANCH XLXN_102
            WIRE 1392 1760 1424 1760
            WIRE 1392 1760 1392 1904
            WIRE 1392 1904 2736 1904
            WIRE 2624 1040 2736 1040
            WIRE 2736 1040 2736 1904
        END BRANCH
        BEGIN BRANCH CLK_50Hz
            WIRE 192 464 224 464
            WIRE 224 464 256 464
            WIRE 224 352 224 464
            WIRE 224 352 1360 352
            WIRE 1360 352 1360 800
            WIRE 1360 800 1424 800
        END BRANCH
        BEGIN BRANCH XLXN_106
            WIRE 1328 1056 1424 1056
            WIRE 1328 1056 1328 1952
            WIRE 1328 1952 3456 1952
            WIRE 3408 832 3456 832
            WIRE 3456 832 3456 1952
        END BRANCH
        BEGIN INSTANCE XLXI_49 2928 368 R0
        END INSTANCE
        BEGIN BRANCH XLXN_112(3:0)
            WIRE 2960 1024 3024 1024
            WIRE 2960 1024 2960 1200
            WIRE 2960 1200 3472 1200
            WIRE 3408 272 3472 272
            WIRE 3472 272 3472 1200
        END BRANCH
        BEGIN BRANCH XLXN_113(3:0)
            WIRE 2848 336 2928 336
            WIRE 2848 336 2848 432
            WIRE 2848 432 3488 432
            WIRE 3488 432 3488 1088
            WIRE 3408 1088 3488 1088
        END BRANCH
        BEGIN BRANCH XLXN_114(1:0)
            WIRE 1808 1824 1904 1824
            WIRE 1904 272 1904 1824
            WIRE 1904 272 2928 272
        END BRANCH
        BEGIN BRANCH RESET
            WIRE 688 1552 688 2528
            WIRE 688 1552 848 1552
            WIRE 848 1552 1232 1552
            WIRE 1232 1552 1232 1936
            WIRE 1232 1936 2704 1936
            WIRE 1232 1552 1344 1552
            WIRE 848 1344 848 1552
            WIRE 1344 1312 1424 1312
            WIRE 1344 1312 1344 1552
            WIRE 2704 960 3024 960
            WIRE 2704 960 2704 1936
        END BRANCH
        BEGIN INSTANCE XLXI_47 1424 1728 R0
        END INSTANCE
        BEGIN BRANCH PP
            WIRE 752 1568 1360 1568
            WIRE 752 1568 752 2336
            WIRE 1360 1248 1424 1248
            WIRE 1360 1248 1360 1568
        END BRANCH
        BEGIN BRANCH SA
            WIRE 816 1584 1376 1584
            WIRE 816 1584 816 2528
            WIRE 1376 1376 1424 1376
            WIRE 1376 1376 1376 1584
        END BRANCH
        BEGIN BRANCH SF
            WIRE 880 1600 1392 1600
            WIRE 880 1600 880 2336
            WIRE 1392 1440 1424 1440
            WIRE 1392 1440 1392 1600
        END BRANCH
        BEGIN BRANCH SG
            WIRE 944 1616 1408 1616
            WIRE 944 1616 944 2528
            WIRE 1408 1504 1424 1504
            WIRE 1408 1504 1408 1616
        END BRANCH
        BEGIN BRANCH LED1
            WIRE 1184 2096 1872 2096
            WIRE 1184 2096 1184 2528
            WIRE 1808 1024 1872 1024
            WIRE 1872 1024 1872 2096
        END BRANCH
        BEGIN BRANCH SENYAL
            WIRE 1248 2112 1248 2336
            WIRE 1248 2112 3440 2112
            WIRE 3408 960 3440 960
            WIRE 3440 960 3440 2112
        END BRANCH
        BEGIN BRANCH LED2
            WIRE 1120 2080 1120 2336
            WIRE 1120 2080 1856 2080
            WIRE 1808 1248 1856 1248
            WIRE 1856 1248 1856 2080
        END BRANCH
        IOMARKER 752 2336 PP R90 28
        IOMARKER 880 2336 SF R90 28
        IOMARKER 1120 2336 LED2 R90 28
        IOMARKER 1248 2336 SENYAL R90 28
        IOMARKER 688 2528 RESET R90 28
        IOMARKER 816 2528 SA R90 28
        IOMARKER 944 2528 SG R90 28
        IOMARKER 1184 2528 LED1 R90 28
        BEGIN BRANCH XLXN_135
            WIRE 640 592 2960 592
            WIRE 2960 592 2960 832
            WIRE 2960 832 3024 832
        END BRANCH
        BEGIN BRANCH XLXN_93
            WIRE 1232 960 1248 960
            WIRE 1248 864 1424 864
            WIRE 1248 864 1248 960
        END BRANCH
        BEGIN BRANCH CLK_1Hz
            WIRE 640 656 832 656
            WIRE 832 656 832 960
            WIRE 832 960 848 960
            WIRE 832 656 1920 656
            WIRE 1920 656 1920 1168
            WIRE 1920 1168 2240 1168
        END BRANCH
        BEGIN INSTANCE XLXI_55 848 1376 R0
        END INSTANCE
        BEGIN BRANCH CLK_1Hz
            WIRE 320 832 384 832
            WIRE 320 832 320 992
            WIRE 320 992 384 992
            WIRE 320 992 320 1136
            WIRE 320 1136 320 1280
            WIRE 320 1280 384 1280
            WIRE 320 1136 384 1136
        END BRANCH
        BEGIN BRANCH BTN1
            WIRE 240 1056 384 1056
        END BRANCH
        BEGIN BRANCH BTN2
            WIRE 240 1200 384 1200
        END BRANCH
        BEGIN BRANCH BTN3
            WIRE 240 1344 384 1344
        END BRANCH
        BEGIN INSTANCE XLXI_45 384 1088 R0
        END INSTANCE
        BEGIN INSTANCE XLXI_43 384 1376 R0
        END INSTANCE
        BEGIN INSTANCE XLXI_46 384 1232 R0
        END INSTANCE
        BEGIN INSTANCE XLXI_44 384 928 R0
        END INSTANCE
        BEGIN BRANCH XLXN_147
            WIRE 768 832 800 832
            WIRE 800 832 800 1024
            WIRE 800 1024 848 1024
        END BRANCH
        BEGIN BRANCH XLXN_148
            WIRE 768 992 784 992
            WIRE 784 992 784 1088
            WIRE 784 1088 848 1088
        END BRANCH
        BEGIN BRANCH XLXN_149
            WIRE 768 1136 800 1136
            WIRE 800 1136 800 1152
            WIRE 800 1152 848 1152
        END BRANCH
        BEGIN BRANCH XLXN_150
            WIRE 768 1280 800 1280
            WIRE 800 1216 800 1280
            WIRE 800 1216 848 1216
        END BRANCH
        BEGIN BRANCH XLXN_153
            WIRE 1232 1216 1280 1216
            WIRE 1280 1120 1424 1120
            WIRE 1280 1120 1280 1216
        END BRANCH
        BEGIN BRANCH XLXN_154
            WIRE 1232 1344 1296 1344
            WIRE 1296 1184 1424 1184
            WIRE 1296 1184 1296 1344
        END BRANCH
        BEGIN BRANCH DA
            WIRE 1232 1088 1312 1088
            WIRE 1312 992 1424 992
            WIRE 1312 992 1312 1088
        END BRANCH
        BEGIN BRANCH AP
            WIRE 1024 2032 1024 2448
            WIRE 1024 2032 1840 2032
            WIRE 1264 304 1264 928
            WIRE 1264 928 1424 928
            WIRE 1264 304 1840 304
            WIRE 1840 304 1840 2032
        END BRANCH
        BEGIN BRANCH BTN0
            WIRE 240 896 384 896
        END BRANCH
        IOMARKER 240 896 BTN0 R180 28
        IOMARKER 240 1056 BTN1 R180 28
        IOMARKER 240 1200 BTN2 R180 28
        IOMARKER 240 1344 BTN3 R180 28
        IOMARKER 1024 2448 AP R90 28
    END SHEET
END SCHEMATIC
